ChatAlertSettings = class(Turbine.UI.Control)
function ChatAlertSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetParent(parent)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(0,75);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local colorTurn = 0
    local prevItem = nil
    local prevColour = nil
    local selectedName = nil   
    local selectedPhrase = nil 

    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(self)
    InfoLabel:SetSize(700, 30)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(30, 460)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("NOTE: Names are approximate due to not recognising most special characters, this is handeled automatically. Reload the plugin to see the effects of your actions.")

    self.ChatLabelItem = function(box, name, alert, ph)
        local listItem = Turbine.UI.Control();
        listItem:SetVisible(true)
        listItem:SetSize( 600, 50 );
        listItem:SetMouseVisible(true)
        local colourddd = 0.125 + colorTurn * 0.125
        listItem:SetBackColor(Turbine.UI.Color(colourddd, colourddd, colourddd))
        if colorTurn == 1 then
            colorTurn = 0
        else
            colorTurn = 1
        end
        --listItem:SetBackColor(GetRandomColour())

        --    ["Immolated"] = {3, Wounds, CureIcon, false, SoundEffects["Beepq"]},
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(600, 20)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetTop(2)
        NameLabel:SetMarkupEnabled(true)
        NameLabel:SetText("<rgb=#0071b8>Approximate source:</rgb> <rgb=#FF9900>" .. name .. " <rgb=#0071b8>Key phrase: </rgb>" .. ph)

        local AlertLabel  = Turbine.UI.Label()
        AlertLabel:SetParent(listItem)
        AlertLabel:SetSize(200, 20)
        AlertLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        AlertLabel:SetMouseVisible(false)
        AlertLabel:SetMultiline(false)
        AlertLabel:SetTop(2)
        AlertLabel:SetMarkupEnabled(true)
        AlertLabel:SetText("<rgb=#0071b8>Alert:</rgb> <rgb=#FF9900>" .. alert[2])
        AlertLabel:SetPosition(400, 20)

        local DurationLabel = Turbine.UI.Label()
        DurationLabel:SetParent(listItem)
        DurationLabel:SetSize(100, 20)
        DurationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        DurationLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DurationLabel:SetTop(2)
        DurationLabel:SetPosition(0, 20)
        DurationLabel:SetMarkupEnabled(true)
        DurationLabel:SetText("<rgb=#0071b8>Duration:</rgb> <rgb=#FF9900>" .. alert[1])

        local DurationLabel = Turbine.UI.Label()
        DurationLabel:SetParent(listItem)
        DurationLabel:SetSize(100, 20)
        DurationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DurationLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DurationLabel:SetTop(2)
        DurationLabel:SetPosition(90, 20)
        DurationLabel:SetMarkupEnabled(true)
        local yesno = nil
        if alert[4] then
            yesno = "<rgb=#00FF00>yes"
        else
            yesno = "<rgb=#FF0000>no"
        end 
        DurationLabel:SetText("<rgb=#0071b8>Countdown:</rgb> " .. yesno)

        local DurationLabel = Turbine.UI.Label()
        DurationLabel:SetParent(listItem)
        DurationLabel:SetSize(300, 20)
        DurationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DurationLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DurationLabel:SetTop(2)
        DurationLabel:SetPosition(140, 20)
        DurationLabel:SetMarkupEnabled(true)
        if alert[5] ~= nil then 
            DurationLabel:SetText("<rgb=#0071b8>Soundeffect: <rgb=#00FF00>" .. alert[5])
        else
            DurationLabel:SetText("<rgb=#0071b8>Soundeffect: <rgb=#FF0000>No Soundeffect")
        end

        listItem.MouseClick = function()
            if prevItem ~= nil then
                prevItem:SetBackColor(prevColour)
            end
            prevItem = listItem
            prevColour = prevItem:GetBackColor()
            listItem:SetBackColor(Turbine.UI.Color.White)
            selectedName = name
            selectedPhrase = ph
        end

        return (listItem)
    end

    self.CreateChatItem = function(box, name, effect, ph)
        box:AddItem( self.ChatLabelItem(box, name, effect, ph) );
    end

    local SelfEffects = Turbine.UI.Control()
    SelfEffects:SetSize(width, height - 100)
    SelfEffects:SetParent(self)
    SelfEffects:SetPosition(0, 40)

    local container = Turbine.UI.ListBox()
    container:SetParent(SelfEffects)
    container:SetSize(600, height - 200)
    container:SetPosition(30, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    containerScrollbar:SetParent( SelfEffects );
    containerScrollbar:SetPosition( 630 - 10, 50 );
    containerScrollbar:SetSize( 10, height - 200 );
    container:SetVerticalScrollBar( containerScrollbar );

    local sortedEffects = {}
    for key, value in pairs(A) do table.insert( sortedEffects,key ) end
    table.sort( sortedEffects )

    for key, value in pairs(sortedEffects) do
        for key2, value2 in pairs(A[value]) do
            self.CreateChatItem(container, value, value2, key2)
        end
    end

    local ItemTextBox0 = Turbine.UI.Lotro.TextBox()
    ItemTextBox0:SetParent(self)
    ItemTextBox0:SetSize(100, 30)
    ItemTextBox0:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox0:SetMouseVisible(false)
    ItemTextBox0:SetPosition(30, 430)
    ItemTextBox0:SetMultiline(false)
    ItemTextBox0:SetText("Source")

    local ItemTextBox = Turbine.UI.Lotro.TextBox()
    ItemTextBox:SetParent(self)
    ItemTextBox:SetSize(400, 30)
    ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox:SetMouseVisible(false)
    ItemTextBox:SetPosition(130, 430)
    ItemTextBox:SetMultiline(false)
    ItemTextBox:SetText("Key Phrase")

    local ItemTextBox2 = Turbine.UI.Lotro.TextBox()
    ItemTextBox2:SetParent(self)
    ItemTextBox2:SetSize(400, 30)
    ItemTextBox2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox2:SetMouseVisible(false)
    ItemTextBox2:SetMultiline(false)
    ItemTextBox2:SetPosition(130, 400)
    ItemTextBox2:SetText("Alert")

    local ItemTextBox3 = Turbine.UI.Lotro.TextBox()
    ItemTextBox3:SetParent(self)
    ItemTextBox3:SetSize(100, 30)
    ItemTextBox3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox3:SetMouseVisible(false)
    ItemTextBox3:SetPosition(30, 400)
    ItemTextBox3:SetMultiline(false)
    ItemTextBox3:SetText("Duration")

    local CountdownButton = Turbine.UI.Lotro.Button()
    CountdownButton:SetParent(self)
    CountdownButton:SetSize(100, 15)
    CountdownButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    CountdownButton:SetMouseVisible(true)
    CountdownButton:SetPosition(530, 400)
    CountdownButton:SetText("Countdown")

    CountdownButton.Click = function()
        if CountdownButton:GetText() == "No" then
            CountdownButton:SetText("Yes")
        else
            CountdownButton:SetText("No")
        end
    end

    local menu = Turbine.UI.ContextMenu()

    local SoundeffectButton = Turbine.UI.Lotro.Button()
    SoundeffectButton:SetParent(self)
    SoundeffectButton:SetSize(100, 15)
    SoundeffectButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SoundeffectButton:SetMouseVisible(true)
    SoundeffectButton:SetPosition(530, 420)
    SoundeffectButton:SetText("SoundEffect")

    SoundeffectButton.Click = function()
        menu:ShowMenu()
    end

    local menuItems = menu:GetItems()
    for key, value in pairs( SoundEffects ) do
        local menuItem = Turbine.UI.MenuItem( key )
        menuItems:Add(menuItem)
        menuItem.Click = function()
            SoundeffectButton:SetText(key)
        end
        --ChatOutput(fontName)
    end

    local CreateButton = Turbine.UI.Lotro.Button()
    CreateButton:SetParent(self)
    CreateButton:SetSize(100, 15)
    CreateButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    CreateButton:SetMouseVisible(true)
    CreateButton:SetPosition(530, 440)
    CreateButton:SetText("Make Alert")

    CreateButton.Click = function()
        local name = GetNameDemo(ItemTextBox0:GetText())
        local phrase = ItemTextBox:GetText()
        local alert = ItemTextBox2:GetText()
        local duration = tonumber(ItemTextBox3:GetText() )
        local countdown = CountdownButton:GetText()
        local soundeffect = SoundeffectButton:GetText()
        if phrase ~= "Key Phrase" and alert ~= "Alert" and duration ~= nil and countdown ~= "Countdown" and soundeffect ~= "SoundEffect" then
            if countdown == "No" then 
                countdown = nil
            else
                countdown = true
            end

            local item = {duration, alert, nil, countdown, SoundEffects[soundeffect]}
            if AddedChatAlerts[name] == nil then
                AddedChatAlerts[name] = {}
            end
            AddedChatAlerts[name][phrase] = item
        end
    end

    local SelfEffects2 = Turbine.UI.Control()
    SelfEffects2:SetSize(width, height - 100)
    SelfEffects2:SetParent(self)
    SelfEffects2:SetPosition(0, 40)
    SelfEffects2:SetVisible(false)

    local container = Turbine.UI.ListBox()
    container:SetParent(SelfEffects2)
    container:SetSize(600, height - 200)
    container:SetPosition(30, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    containerScrollbar:SetParent( SelfEffects2 );
    containerScrollbar:SetPosition( 630 - 10, 50 );
    containerScrollbar:SetSize( 10, height - 200 );
    container:SetVerticalScrollBar( containerScrollbar );

    local sortedEffects = {}
    for key, value in pairs(RemovedChatAlerts) do table.insert( sortedEffects,key ) end
    table.sort( sortedEffects )

    for key, value in pairs(sortedEffects) do
        for key2, value2 in pairs(RemovedChatAlerts[value]) do
            self.CreateChatItem(container, value, value2, key2)
        end
    end

    
    local ReAddButton = Turbine.UI.Lotro.Button()
    ReAddButton:SetParent(self)
    ReAddButton:SetSize(100, 15)
    ReAddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ReAddButton:SetMouseVisible(true)
    ReAddButton:SetPosition(635, 90)
    ReAddButton:SetVisible(false)
    ReAddButton:SetText("Re-Add effect")

    ReAddButton.Click = function()
        RemovedChatAlerts[selectedName][selectedPhrase] = nil
    end

    local RemoveButton = Turbine.UI.Lotro.Button()
    RemoveButton:SetParent(self)
    RemoveButton:SetSize(100, 15)
    RemoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    RemoveButton:SetMouseVisible(true)
    RemoveButton:SetPosition(635, 120)
    RemoveButton:SetText("Remove effect")

    RemoveButton.Click = function()
        if selectedName == nil or selectedPhrase == nil then return end
        if AddedChatAlerts[selectedName] ~= nil and AddedChatAlerts[selectedName][selectedPhrase] then
            AddedChatAlerts[selectedName][selectedPhrase] = nil
        else
            if RemovedChatAlerts[selectedName] == nil then
                RemovedChatAlerts[selectedName] = {}
            end
            RemovedChatAlerts[selectedName][selectedPhrase] = A[selectedName][selectedPhrase]
        end
    end


    local SwitchButton = Turbine.UI.Lotro.Button()
    SwitchButton:SetParent(self)
    SwitchButton:SetSize(150, 15)
    SwitchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SwitchButton:SetMouseVisible(true)
    SwitchButton:SetPosition(30, 40)
    SwitchButton:SetText("Chat alerts")

    SwitchButton.Click = function()
        SelfEffects:SetVisible(true)
        SelfEffects2:SetVisible(false)
        ReAddButton:SetVisible(false)
        RemoveButton:SetVisible(true)
    end

    local SwitchButton = Turbine.UI.Lotro.Button()
    SwitchButton:SetParent(self)
    SwitchButton:SetSize(150, 15)
    SwitchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SwitchButton:SetMouseVisible(true)
    SwitchButton:SetPosition(180, 40)
    SwitchButton:SetText("Removed Alerts")

    SwitchButton.Click = function()
        SelfEffects:SetVisible(false)
        SelfEffects2:SetVisible(true)
        ReAddButton:SetVisible(true)
        RemoveButton:SetVisible(false)
    end


    

end

