CountdownWindow = class(Turbine.UI.Window)
function CountdownWindow:Constructor()
    Turbine.UI.Window.Constructor(self);
    local width = Settings.CWidth
    local height = Settings.CHeight
    local x = Settings.CX
    local y = Settings.CY
    local cooldownTimer = -100
    local lastNumber = -100

    self:SetSize(width,height);
    self:SetPosition(x,y);
    self:SetZOrder(1);

    self:SetWantsKeyEvents(true)
    self:SetMouseVisible(false)
    self:SetVisible(true)

    self.countdownBox = Turbine.UI.Label()
    self.countdownBox:SetParent(self)
    self.countdownBox:SetSize(width, height - 20)
    self.countdownBox:SetPosition(0,20)
    self.countdownBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.countdownBox:SetFont(Settings.CFont)
    self.countdownBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.countdownBox:SetMouseVisible(false)
    self.countdownBox:SetVisible(false)

    local moveBox = MoveBox(self, width, height, "Countdown")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.ExecuteUpdate = function(sender, delta)
        cooldownTimer = cooldownTimer - delta
        local wholeNumber = math.ceil(cooldownTimer)
        self:SetZOrder(1);
    
        if (wholeNumber <= -1) then
            self.countdownBox:SetVisible(false)
            --self:SetWantsUpdates(false)
            Updater:UnSubscribe(self)
        end
    
        -- Handle < 5 colour change
        if(wholeNumber <= 5) then
            self.countdownBox:SetForeColor(Turbine.UI.Color(.40,.0,.0))
        else
            self.countdownBox:SetForeColor(Turbine.UI.Color(.95,.67,.04))
        end
    
        if wholeNumber ~= lastNumber then
            if (wholeNumber <= 10) then
                if SoundEffects[tostring(wholeNumber)] ~= nil then
                    Sounds:PlaySoundEffect(SoundEffects[tostring(wholeNumber)])
                end
            end
        
            if (wholeNumber == 0) then
                self.countdownBox:SetText("GO")
                if SoundEffects["GO"] ~= nil then Sounds:PlaySoundEffect(SoundEffects["GO"]) end
                --ChatOutput("GO")
            end
        
            if (wholeNumber >= 1) then
                self.countdownBox:SetText(math.ceil(wholeNumber))
                --ChatOutput(cooldownTimer)
            end
            
            lastNumber = wholeNumber
        end
    end

    
    self.Countdown = function(sender, duration)
        self.countdownBox:SetForeColor(Turbine.UI.Color(.95,.67,.04))
        cooldownTimer = duration
        lastNumber = duration + 1
        oldGameTime = Turbine.Engine.GetGameTime()
        self.countdownBox:SetText(cooldownTimer)
        self.countdownBox:SetVisible(true)
        --countdownWindow:SetWantsUpdates(true)
        Updater:Subscribe(self)
    end

    self.GetCountdown = function()
        return(cooldownTimer)
    end
end