-- Normal timer
Counter = class(Turbine.UI.Control)
function Counter:Constructor(parent, width, height, elements, duration, message, font, colour1, colour2, colour3, colour4, colour5, icon)

    --ChatOutput(message)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width, height)
    self:SetPosition(0, elements * height)
    self:SetOpacity(1)
    self:SetVisible(true)

    local offset = 0

    if icon ~= nil then
        offset = 32
    end

    local opacityWindow = Turbine.UI.Window()
    opacityWindow:SetParent(self)
    opacityWindow:SetVisible(true)
    opacityWindow:SetPosition(0, 0)
    opacityWindow:SetSize(width, height)
    opacityWindow:SetOpacity(0.4)

    local outLine = Turbine.UI.Label()
    outLine:SetParent(opacityWindow)
    outLine:SetSize(width, height)
    outLine:SetMouseVisible(false)
    outLine:SetVisible(true)
    outLine:SetBackColor(Turbine.UI.Color(0,0,0))
    
    local backLabel = Turbine.UI.Label()
    backLabel:SetParent(opacityWindow)
    backLabel:SetSize(width - 2 - offset, height - 2)
    backLabel:SetPosition(1 + offset,1)
    backLabel:SetMouseVisible(false)
    backLabel:SetVisible(true)

    local frontLabel = Turbine.UI.Label()
    frontLabel:SetParent(opacityWindow)
    frontLabel:SetPosition(1 + offset,1)
    frontLabel:SetSize(width - 2 - offset, height - 2)
    frontLabel:SetBackColor(colour5)

    local opacityWindow2 = Turbine.UI.Window()
    opacityWindow2:SetParent(self)
    opacityWindow2:SetVisible(true)
    opacityWindow2:SetPosition(0, 0)
    opacityWindow2:SetSize(width, height)
    --self.opacityWindow:SetOpacity(0.5)

    if icon ~= nil then
        local iconLabel = Turbine.UI.Label()
        iconLabel:SetParent(opacityWindow2)
        iconLabel:SetPosition(1,1)
        iconLabel:SetSize(32, 32)
        iconLabel:SetMouseVisible(false)
        iconLabel:SetVisible(true)
        iconLabel:SetBackground(icon)
    end

    local durationVisible = true
    if duration > 99999 then
        durationVisible = false
    end

    local textLabel = Turbine.UI.Label()
    textLabel:SetParent(opacityWindow2)
    textLabel:SetPosition(1 + offset + 5, 1)
    textLabel:SetSize(width - 65, height)
    textLabel:SetMouseVisible(false)
    textLabel:SetVisible(true)
    textLabel:SetMultiline(false)
    textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    textLabel:SetFont(font)
    textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    textLabel:SetMouseVisible(false)
    textLabel:SetText(message)
    textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    textLabel:SetOutlineColor(OutlineColor)
    textLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )

    local durationLabel = Turbine.UI.Label()
    durationLabel:SetParent(opacityWindow2)
    durationLabel:SetPosition(width - 25, 1)
    durationLabel:SetSize(25, height)
    durationLabel:SetFont(font)
    durationLabel:SetVisible(durationVisible)
    durationLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    durationLabel:SetMouseVisible(false)
    durationLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    durationLabel:SetOutlineColor(OutlineColor)
    durationLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
    durationLabel:SetMultiline(false)
    durationLabel:SetText(duration)
    durationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)

    local s = message
    local number = duration
    local maxNumber = duration

    self.Destroy = function()
        self:SetVisible(false)
        local offset = nil
        local opacityWindow = nil
        local outLine = nil
        local backLabel = nil
        local frontLabel = nil
        local opacityWindow2 = nil
        local iconLabel = nil
        local durationVisible = nil
        local textLabel = nil
        local durationLabel = nil

        self:SetParent(nil)
        self = nil
    end

    self.UpdateText = function(sender, delta)
        number = number - delta
        if number <= 5 then
            durationLabel:SetText(Round(number, 1))
        else 
            durationLabel:SetText(math.floor(number))
        end
        self:UpdateColour()
    end

    self.UpdateColour = function()
        if number == 0 then
            backLabel:SetBackColor(colour1)
        elseif number <= 5 then
            backLabel:SetBackColor(colour2)
        elseif number <= 10 then
            --self.backLabel:SetBackColor(colour3)
        else
            backLabel:SetBackColor(colour4)
        end
        frontLabel:SetSize(number / duration * (width - 2 - offset), (height - 2))
    end

    self:UpdateColour()

    self.GetRemainingTime = function()
        return(number)
    end

    self.GetDuration = function()
        return(maxNumber)
    end

    self.ChangeDuration = function(sender, newNumber)
        --ChatOutput(newNumber)
        number = newNumber
    end
    --ChatOutput(message .. elements)
end

-- Timer based on effect display
Counter2 = class(Turbine.UI.Control)
function Counter2:Constructor(parent, width, height, elements, duration, message, font, colour1, colour2, colour3, colour4, colour5, icon, effect)

    --ChatOutput(effect:GetName())
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width, height)
    self:SetPosition(0, elements * height)
    self:SetOpacity(1)
    self:SetVisible(true)

    local offset = 0

    if effect ~= nil then
        offset = height
    end

    local opacityWindow = Turbine.UI.Window()
    opacityWindow:SetParent(self)
    opacityWindow:SetVisible(true)
    opacityWindow:SetPosition(0, 0)
    opacityWindow:SetSize(width, height)
    opacityWindow:SetOpacity(0.4)

    local outLine = Turbine.UI.Label()
    outLine:SetParent(opacityWindow)
    outLine:SetSize(width, height)
    outLine:SetMouseVisible(false)
    outLine:SetVisible(true)
    outLine:SetBackColor(Turbine.UI.Color(0,0,0))
    
    local backLabel = Turbine.UI.Label()
    backLabel:SetParent(opacityWindow)
    backLabel:SetSize(width - 2 - offset, height - 2)
    backLabel:SetPosition(1 + offset,1)
    backLabel:SetMouseVisible(false)
    backLabel:SetVisible(true)

    local frontLabel = Turbine.UI.Label()
    frontLabel:SetParent(opacityWindow)
    frontLabel:SetPosition(1 + offset,1)
    frontLabel:SetSize(width - 2 - offset, height - 2)
    frontLabel:SetBackColor(colour5)

    local opacityWindow2 = Turbine.UI.Window()
    opacityWindow2:SetParent(self)
    opacityWindow2:SetVisible(true)
    opacityWindow2:SetPosition(0, 0)
    opacityWindow2:SetSize(width, height)
    --self.opacityWindow:SetOpacity(0.5)

    if effect ~= nil then
        local iconLabel = Turbine.UI.Lotro.EffectDisplay()
        iconLabel:SetEffect(effect)
        iconLabel:SetParent(opacityWindow2)
        iconLabel:SetPosition(1,1)
        iconLabel:SetSize(height, height)
        iconLabel:SetMouseVisible(false)
        iconLabel:SetVisible(true)
        --self.iconLabel:SetBackground(icon)
    end

    local durationVisible = true
    if duration > 99999 then
        durationVisible = false
    end

    local textLabel = Turbine.UI.Label()
    textLabel:SetParent(opacityWindow2)
    textLabel:SetPosition(1 + offset + 5, 1)
    textLabel:SetSize(width - 45, height)
    textLabel:SetMouseVisible(false)
    textLabel:SetVisible(true)
    textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    textLabel:SetFont(font)
    textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    textLabel:SetMouseVisible(false)
    textLabel:SetText(message)
    textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    textLabel:SetOutlineColor(OutlineColor)
    textLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
    textLabel:SetMultiline(false)

    local durationLabel = Turbine.UI.Label()
    durationLabel:SetParent(opacityWindow2)
    durationLabel:SetPosition(width - 20, 1)
    durationLabel:SetSize(20, 20)
    durationLabel:SetFont(font)
    durationLabel:SetVisible(durationVisible)
    durationLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    durationLabel:SetMouseVisible(false)
    durationLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    durationLabel:SetOutlineColor(OutlineColor)
    durationLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
    durationLabel:SetMultiline(false)
    durationLabel:SetText(duration)
    durationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.durationLabel:
    

    local s = message
    local number = duration
    local maxNumber = duration
    local colourEvent = 5
    local oldnumber = duration
    if colour2 == nil then colourEvent = -1 end

    self.Destroy = function()
        self:SetVisible(false)
        local offset = nil
        local opacityWindow = nil
        local outLine = nil
        local backLabel = nil
        local frontLabel = nil
        local opacityWindow2 = nil
        local iconLabel = nil
        local durationVisible = nil
        local textLabel = nil
        local durationLabel = nil

        self:SetParent(nil)
        self = nil
    end

    self.UpdateText = function(sender, delta)
        if number > 99999 then return end
        number = number - delta
        if oldnumber - number > 0.05 then
            if number <= 5 then
                durationLabel:SetText(Round(number, 1))
            else 
                durationLabel:SetText(math.floor(number))
            end
            self:UpdateColour()
            oldnumber = number
        end
    end

    self.UpdateColour = function()
        if number <= colourEvent then
            if number == 0 then
                backLabel:SetBackColor(colour1)
                colourEvent = -5
            elseif number <= 5 then
                backLabel:SetBackColor(colour2)
                colourEvent = 0
            elseif number <= 10 then
                --self.backLabel:SetBackColor(colour3)
            else
                backLabel:SetBackColor(colour4)
            end
        end
        frontLabel:SetSize(number / duration * (width - 2 - offset), (height - 2))
    end

    self:UpdateColour()

    self.GetRemainingTime = function()
        return(number)
    end

    self.GetDuration = function()
        return(maxNumber)
    end

    self.ChangeDuration = function(sender, newNumber)
        --ChatOutput(newNumber)
        number = newNumber
        oldnumber = newNumber
    end

    self.ChangeName = function(sender, newName)
        textLabel:SetText(newName)
    end
    --ChatOutput(message .. elements)
end