function InitiateHandlers()
    Player.InCombatChanged = function(sender, arg)

        if combatTimer ~= nil then combatTimer:CombatChanged() end
    
        if Target ~= nil then Target:CombatUpdate() end
        
    end
end

UpdateHandler = class(Turbine.UI.Control)
function UpdateHandler:Constructor()
    Turbine.UI.Control.Constructor(self);
    self:SetWantsUpdates(true)

    local oldGameTime = Turbine.Engine.GetGameTime()

    local UpdateList = {}

    self.Update = function()
        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == oldGameTime then
            return(true)
        end
        local delta = currentGameTime - oldGameTime

        --ChatOutput(collectgarbage("count")*1024)
        --ChatOutput(collectgarbage("count")*1024)

        for key, value in pairs(UpdateList) do
            key:ExecuteUpdate(delta)
        end

        oldGameTime = currentGameTime
    end

    self.Subscribe = function(sender, object)
        UpdateList[object] = true
    end

    self.UnSubscribe = function(sender, object)
        UpdateList[object] = nil
    end
end

GarbageHandler = class(Turbine.UI.Control)
function GarbageHandler:Constructor()
    Turbine.UI.Control.Constructor(self);

    local UpdateInterval = 30
    local UpdateTime = UpdateInterval

    Updater:Subscribe(self)

    self.ScheduleClear = function()
        UpdateTime = 5
        Updater:Subscribe(self)
    end

    self.UnScheduleClear = function()
        Updater:UnSubscribe(self)
    end

    self.ExecuteGC = function()
        
        --ChatOutput("Pre Clear: " .. collectgarbage("count")*1024)

        -- Reset group data
        RefreshGroupData()

        -- Reset target data
        if Target ~= nil then Target:RefreshData() end

        -- Reset timer
        UpdateTime = UpdateInterval

        --ChatOutput("Post Clear: " .. collectgarbage("count")*1024)
    end

    self.ExecuteUpdate = function(sender, delta)
        UpdateTime = UpdateTime - delta

        if UpdateTime < 0 then self.ExecuteGC() end
    end


end

