LootWindow = class(Turbine.UI.Lotro.Window)

function LootWindow:Constructor()
    local width = Settings.LOWidth
    local height = Settings.LOHeight
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Lotro.Window.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(x,y);
    self:SetWantsKeyEvents(true)
    self:SetText("Loot Locks")
    self:SetVisible(false)

    local UIparent = nil

    self.KeyDown = function(sender, args)
        if args["Action"] == 145 then
            if self:IsVisible() then self:SetVisible(false) end
        end
    end

    self.UpdateUI = function()
        if LootLocks == nil then
            LootLocks = {}
            LootLocks.LastReset = BeginningOfPrimeTime
            LootLocks.LastT1Reset = BeginningOfPrimeTime
        end
        local windowWith = 0
        local windowHeight = 0
        HandleLootUpdate()
        UIparent = nil
        if LootLocks ~= nil then
            if LootLocks.Characters ~= nil then
                UIparent = Turbine.UI.Control()
                UIparent:SetParent(self)
                UIparent:SetSize(width, height - 50)
                UIparent:SetPosition(0, 50)
                UIparent.NameBar = Turbine.UI.Control()
                UIparent.NameBar:SetParent(UIparent)
                UIparent.NameBar:SetPosition(10, 0)
                UIparent.NameBar:SetSize(100 + tablelength(LootLocks.Characters) * 100, 15)
                UIparent.NameBar:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

                GetPartialLabel(UIparent.NameBar, "Chest / Char", colour, font, Turbine.UI.ContentAlignment.MiddleLeft, 0)

                local nameIndex = 1
                for char, value in pairs (LootLocks.Characters) do
                    GetPartialLabel(UIparent.NameBar, char, colour, font, Turbine.UI.ContentAlignment.MiddleCenter, nameIndex)
                    nameIndex = nameIndex + 1
                end
    
                local tempIndex = 1

                -- Create space
                UIparent.UISpace = Turbine.UI.Control()
                UIparent.UISpace:SetParent(UIparent)
                UIparent.UISpace:SetPosition(10, 15 * tempIndex)
                UIparent.UISpace:SetSize(100 + tablelength(LootLocks.Characters) * 100, 15)
                local colourNumb = tempIndex % 2
                UIparent.UISpace:SetBackColor(Turbine.UI.Color(0.125 + colourNumb * 0.125, 0.125 + colourNumb * 0.125, 0.125 + colourNumb * 0.125))

                tempIndex = tempIndex + 1

                -- Handle instance locks
                if LootLocks.Locks ~= nil then
                    table.sort(LootLocks.Locks)
                    local sortedKeys = {}
                    for key, value in pairs(LootLocks.Locks) do table.insert( sortedKeys,key ) end
                    table.sort( sortedKeys )

                    local firstLetter = ""
                    
                    for locks, chest in pairs (sortedKeys) do

                        if firstLetter ~= "" and firstLetter ~= string.sub(chest, 1, 1) then
                            UIparent.UISpace = Turbine.UI.Control()
                            UIparent.UISpace:SetParent(UIparent)
                            UIparent.UISpace:SetPosition(10, 15 * tempIndex)
                            UIparent.UISpace:SetSize(100 + tablelength(LootLocks.Characters) * 100, 15)
                            local colourNumb = tempIndex % 2
                            UIparent.UISpace:SetBackColor(Turbine.UI.Color(0.125 + colourNumb * 0.125, 0.125 + colourNumb * 0.125, 0.125 + colourNumb * 0.125))
            
                            tempIndex = tempIndex + 1
                        end

                        firstLetter = string.sub(chest, 1, 1)

                        UIparent.UIElement = Turbine.UI.Control()
                        UIparent.UIElement:SetParent(UIparent)
                        UIparent.UIElement:SetPosition(10, 15 * tempIndex)
                        UIparent.UIElement:SetSize(100 + tablelength(LootLocks.Characters) * 100, 15)
                        --WriteLine(chest)
                        local temp = chest
                        local numb = tempIndex % 2
                        UIparent.UIElement:SetBackColor(Turbine.UI.Color(0.125 + numb * 0.125, 0.125 + numb * 0.125, 0.125 + numb * 0.125))
                        GetPartialLabel(UIparent.UIElement, chest, colour, font, Turbine.UI.ContentAlignment.MiddleLeft, 0)
        
                        local tempIndex2 = 0
                        for char, value in pairs (LootLocks.Characters) do
                            --ChatOutput(chest.. " " .. char)
                            if LootLocks.Locks[chest][char] ~= nil then
                                -- temp = temp .. " " .. LootLocks.Locks[char]
                                --ChatOutput(tempIndex2)
                                local labelColour = nil
                                if LootLocks.Locks[chest][char] > 0 then
                                    labelColour = Turbine.UI.Color(0, 1, 0)
                                else
                                    labelColour = Turbine.UI.Color(1, 0, 0)
                                end
                                GetPartialLabel(UIparent.UIElement, LootLocks.Locks[chest][char], labelColour, font, Turbine.UI.ContentAlignment.MiddleCenter, 1 + tempIndex2)
                            else
                                    --temp = temp .. " 2" 
                                GetPartialLabel(UIparent.UIElement, 2, Turbine.UI.Color(0, 1, 0), font, Turbine.UI.ContentAlignment.MiddleCenter, 1 + tempIndex2)
                            end
                            tempIndex2 = tempIndex2 + 1
                        end
                        tempIndex = tempIndex + 1
                    end
                end

                if tablelength(LootLocks.Locks) > 0 then
                    -- Create space
                    UIparent.UISpace = Turbine.UI.Control()
                    UIparent.UISpace:SetParent(UIparent)
                    UIparent.UISpace:SetPosition(10, 15 * tempIndex)
                    UIparent.UISpace:SetSize(100 + tablelength(LootLocks.Characters) * 100, 15)
                    local colourNumb = tempIndex % 2
                    UIparent.UISpace:SetBackColor(Turbine.UI.Color(0.125 + colourNumb * 0.125, 0.125 + colourNumb * 0.125, 0.125 + colourNumb * 0.125))

                    tempIndex = tempIndex + 1
                end

                -- Handle T1 raid locks
                if LootLocks.T1RaidLocks ~= nil then
                    local sortedT1RaidKeys = {}
                    for key, value in pairs(LootLocks.T1RaidLocks) do table.insert( sortedT1RaidKeys,key ) end
                    table.sort( sortedT1RaidKeys )

                    for locks, chest in pairs (sortedT1RaidKeys) do
                        UIparent.UIElement = Turbine.UI.Control()
                        UIparent.UIElement:SetParent(UIparent)
                        UIparent.UIElement:SetPosition(10, 15 * tempIndex)
                        UIparent.UIElement:SetSize(100 + tablelength(LootLocks.Characters) * 100, 15)
                        --WriteLine(chest)
                        local temp = chest
                        local numb = tempIndex % 2
                        UIparent.UIElement:SetBackColor(Turbine.UI.Color(0.125 + numb * 0.125, 0.125 + numb * 0.125, 0.125 + numb * 0.125))
                        GetPartialLabel(UIparent.UIElement, chest, colour, font, Turbine.UI.ContentAlignment.MiddleLeft, 0)
        
                        local tempIndex2 = 0
                        for char, value in pairs (LootLocks.Characters) do
                            --ChatOutput(chest.. " " .. char)
                            if LootLocks.T1RaidLocks[chest][char] ~= nil then
                                -- temp = temp .. " " .. LootLocks.Locks[char]
                                --ChatOutput(tempIndex2)
                                local labelColour = nil
                                if LootLocks.T1RaidLocks[chest][char] > 0 then
                                    labelColour = Turbine.UI.Color(0, 1, 0)
                                else
                                    labelColour = Turbine.UI.Color(1, 0, 0)
                                end
                                GetPartialLabel(UIparent.UIElement, LootLocks.T1RaidLocks[chest][char], labelColour, font, Turbine.UI.ContentAlignment.MiddleCenter, 1 + tempIndex2)
                            else
                                    --temp = temp .. " 2" 
                                GetPartialLabel(UIparent.UIElement, 1, Turbine.UI.Color(0, 1, 0), font, Turbine.UI.ContentAlignment.MiddleCenter, 1 + tempIndex2)
                            end
                            tempIndex2 = tempIndex2 + 1
                        end
                        tempIndex = tempIndex + 1
                    end
                end

                -- Create space
                if tablelength(LootLocks.T1RaidLocks) > 0 then
                    UIparent.UISpace = Turbine.UI.Control()
                    UIparent.UISpace:SetParent(UIparent)
                    UIparent.UISpace:SetPosition(10, 15 * tempIndex)
                    UIparent.UISpace:SetSize(100 + tablelength(LootLocks.Characters) * 100, 15)
                    local colourNumb = tempIndex % 2
                    UIparent.UISpace:SetBackColor(Turbine.UI.Color(0.125 + colourNumb * 0.125, 0.125 + colourNumb * 0.125, 0.125 + colourNumb * 0.125))

                    tempIndex = tempIndex + 1
                end

                -- Handle T2/T3 locks
                if LootLocks.RaidLocks ~= nil then
                    local sortedRaidKeys = {}
                    for key, value in pairs(LootLocks.RaidLocks) do table.insert( sortedRaidKeys,key ) end
                    table.sort( sortedRaidKeys )
                    local firstLetter = ""

                    for locks, chest in pairs (sortedRaidKeys) do

                        if firstLetter ~= "" and firstLetter ~= string.sub(chest, 2, 2) then
                            UIparent.UISpace = Turbine.UI.Control()
                            UIparent.UISpace:SetParent(UIparent)
                            UIparent.UISpace:SetPosition(10, 15 * tempIndex)
                            UIparent.UISpace:SetSize(100 + tablelength(LootLocks.Characters) * 100, 15)
                            local colourNumb = tempIndex % 2
                            UIparent.UISpace:SetBackColor(Turbine.UI.Color(0.125 + colourNumb * 0.125, 0.125 + colourNumb * 0.125, 0.125 + colourNumb * 0.125))
            
                            tempIndex = tempIndex + 1
                        end

                        firstLetter = string.sub(chest, 2, 2)
                        UIparent.UIElement = Turbine.UI.Control()
                        UIparent.UIElement:SetParent(UIparent)
                        UIparent.UIElement:SetPosition(10, 15 * tempIndex)
                        UIparent.UIElement:SetSize(100 + tablelength(LootLocks.Characters) * 100, 15)
                        --WriteLine(chest)
                        local temp = chest
                        local numb = tempIndex % 2
                        UIparent.UIElement:SetBackColor(Turbine.UI.Color(0.125 + numb * 0.125, 0.125 + numb * 0.125, 0.125 + numb * 0.125))
                        GetPartialLabel(UIparent.UIElement, chest, colour, font, Turbine.UI.ContentAlignment.MiddleLeft, 0)
        
                        local tempIndex2 = 0
                        for char, value in pairs (LootLocks.Characters) do
                            --ChatOutput(chest.. " " .. char)
                            if LootLocks.RaidLocks[chest][char] ~= nil then
                                -- temp = temp .. " " .. LootLocks.Locks[char]
                                --ChatOutput(tempIndex2)
                                local labelColour = nil
                                if LootLocks.RaidLocks[chest][char] > 0 then
                                    labelColour = Turbine.UI.Color(0, 1, 0)
                                else
                                    labelColour = Turbine.UI.Color(1, 0, 0)
                                end
                                GetPartialLabel(UIparent.UIElement, LootLocks.RaidLocks[chest][char], labelColour, font, Turbine.UI.ContentAlignment.MiddleCenter, 1 + tempIndex2)
                            else
                                    --temp = temp .. " 2" 
                                GetPartialLabel(UIparent.UIElement, 1, Turbine.UI.Color(0, 1, 0), font, Turbine.UI.ContentAlignment.MiddleCenter, 1 + tempIndex2)
                            end
                            tempIndex2 = tempIndex2 + 1
                        end
                        tempIndex = tempIndex + 1
                    end
                end

                -- Create space
                if tablelength(LootLocks.RaidLocks)  > 0 then
                    UIparent.UISpace = Turbine.UI.Control()
                    UIparent.UISpace:SetParent(UIparent)
                    UIparent.UISpace:SetPosition(10, 15 * tempIndex)
                    UIparent.UISpace:SetSize(100 + tablelength(LootLocks.Characters) * 100, 15)
                    local colourNumb = tempIndex % 2
                    UIparent.UISpace:SetBackColor(Turbine.UI.Color(0.125 + colourNumb * 0.125, 0.125 + colourNumb * 0.125, 0.125 + colourNumb * 0.125))

                    tempIndex = tempIndex + 1
                end

                windowWith = 120 + tablelength(LootLocks.Characters) * 100 + windowWith
                --windowHeight = 90 + 15 * tablelength(LootLocks.Locks) + 15 * tablelength(LootLocks.T1RaidLocks) + 15 * tablelength(LootLocks.RaidLocks) + windowHeight + 15
                windowHeight = 90 + 15 * tempIndex

                -- Set window to the appropriate size
                self:SetSize( windowWith, windowHeight)
            else
                self:SetSize(300, 200)
                local NoLootLabel = Turbine.UI.Label()
                NoLootLabel:SetParent(self)
                NoLootLabel:SetPosition(70 , 90);
                NoLootLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
                NoLootLabel:SetSize(140, 15);
                NoLootLabel:SetFont(font);
                NoLootLabel:SetVisible(true);
                NoLootLabel:SetText("No loot locks");
            end
        end
    end
    self.UpdateUI()
end

function GetPartialLabel(parent, text, fontColour, font, fill, index)
    local tempLabel =  Turbine.UI.Label()
    tempLabel:SetParent(parent)
    tempLabel:SetPosition(100 * index , 0);
    tempLabel:SetTextAlignment(fill) -- Turbine.UI.ContentAlignment.MiddleCenter
    --tempLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter) -- Turbine.UI.ContentAlignment.MiddleCenter
    tempLabel:SetSize(100, 15);
    tempLabel:SetForeColor(fontColour)
    tempLabel:SetFont(font);
    tempLabel:SetVisible(true);
    tempLabel:SetText(text);
    --tempLabel:SetBackColor(fontColour)

    --return tempLabel
end

function SaveLoot()
    if lootWindow ~= nil then Turbine.PluginData.Save(Turbine.DataScope.Server, "PrimeLootLocks", LootLocks); end
end

LootButton = class(Turbine.UI.Window)
function LootButton:Constructor()
    Turbine.UI.Window.Constructor(self);
    self:SetSize(100, 100);
    self:SetPosition(360, Turbine.UI.Display.GetHeight() - 20);
    self:SetVisible(true)
    
    self.toggleButton = Turbine.UI.Lotro.Button()
    self.toggleButton:SetParent(self)
    self.toggleButton:SetText("Loot")
    self.toggleButton:SetVisible(true)
    self.toggleButton:SetWidth(100)
    
    self.toggleButton.Click = function()
        lootWindow:SetVisible(not lootWindow:IsVisible())
    end
end

function GetLastReset()
    return(math.floor((Turbine.Engine.GetLocalTime() - BeginningOfPrimeTime)/SecondsInWeek) * SecondsInWeek + BeginningOfPrimeTime)
end

function GetLastT1Reset()
    local lastReset = GetLastReset()
    if lastReset + (SecondsInDay * 2) > Turbine.Engine.GetLocalTime() then
        return lastReset
    elseif lastReset + (SecondsInDay * 4) > Turbine.Engine.GetLocalTime() then
        return lastReset + SecondsInDay * 2
    elseif lastReset + (SecondsInDay * 7) > Turbine.Engine.GetLocalTime() then 
        return lastReset + SecondsInDay * 4
    end
end

function HandleLootUpdate()
    local lastReset = GetLastReset()
    local lastT1Reset = GetLastT1Reset()
    if LootLocks.LastT1Reset == nil then
        LootLocks.LastT1Reset = GetLastT1Reset()
    end
    if lastReset > LootLocks.LastReset then
        ChatOutput( "Clearing lootlock table")
        LootLocks = {}
        LootLocks["LastReset"] = lastReset
    elseif lastT1Reset > LootLocks.LastT1Reset then
        LootLocks.T1RaidLocks = {}
        LootLocks.LastT1Reset = lastT1Reset
    end
end