import "PrimePlugins.RaidTools"
--collectgarbage("stop")

if not(Turbine.Language.EnglishGB == Turbine.Engine.GetLanguage() or Turbine.Language.English == Turbine.Engine.GetLanguage()) then 
    ChatOutput("Set your client to english")
    return
end

Reloader = class(Turbine.UI.Control)
function Reloader:Constructor()
    Turbine.UI.Control.Constructor(self)
    self:SetWantsUpdates(true)
    self.reloaded = false
    self.Update = function()
        if self.reloaded then
            self:SetWantsUpdates(false)    
        elseif not(self.reloaded) then 
            Turbine.PluginManager.UnloadScriptState("PrimeReloader")
            self.reloaded = true
        end
    end
end
reload = Reloader()

function ReloadPlugin()
    AddReload()
    Settings.ReloadData = true
    Turbine.PluginManager.LoadPlugin("PrimeReloader")
end

PluginVersion = plugin:GetVersion()
UpdateSettings() 
ReloadStateData = Turbine.PluginData.Load(Turbine.DataScope.Server, "PrimeReloadData") 
--if Settings.Version == nil or 2.6 > tonumber(Settings.Version) then


if LootLocks == nil then
    LootLocks = {}
end

Player = Turbine.Gameplay.LocalPlayer.GetInstance();
PlayerName = Player:GetName()
Name = Player:GetName();
Party = Player:GetParty();
if Party ~= nil then
    GroupSize = Party:GetMemberCount()
else
    GroupSize = 1
end
LootLocks = Turbine.PluginData.Load(Turbine.DataScope.Server, "PrimeLootLocks")

--Build current party to not break the plugin
Group = {}
GroupIDToName = {}
SetGroup()
SetEffects()

OutOfCombatTime = Turbine.Engine.GetGameTime()

Updater = UpdateHandler()

countdownWindow = CountdownWindow() --
if Settings.CTEnabled then combatTimer = CombatWindow() end --
--if Settings.MEnabled then messageWindow = MessageWindow() end --
if Settings.AEnabled then messageWindow = AlertWindow() end --
if Settings.AEnabled then rezTracker = DNFTracker() end --
if Settings.EEnabled then effectsWindow = EffectsWindow() end --
if Settings.SEnabled then skillCounters = SkillCounters() end --
if Settings.SPEnabled then skillTimers = SkillTimers(0) end --
if Settings.SPEnabled then activeTimers = SkillTimers(1) end --
noteWindow = NoteWindow() --
if Settings.LWEnabled then leaderWindow = LeaderWindow() end
--noteToggleButton = NoteToggleButton() --
--if Settings.LWEnabled then adminPanelButton = AdminPanelButton() end
if Settings.LEnabled then logWindow = LogWindow() end 
--if Settings.LEnabled then logToggleButton = LogToggleButton() end
if Settings.LOEnabled then lootWindow = LootWindow() end
--if Settings.LOEnabled then lootButton = LootButton() end
--if Settings.REnabled then ratTracker = RatTracker() end
reloadWindow = ReloadWindow()
optionsButton = OptionsButton()
skillWindow = SkillWindow()
DungeonWindow = nil --DungeonLog()
ReadyCheck = ReadyWindow()
RcWindow = ReadyCheckWindow()
RCButtonWindow = ReadyButtonWindow()
RButton = ReloadButton()
Sounds = SoundPlayer()
SwappyWarner = SwapWarner()
InstanceController = InstanceHub()
if Settings.TEnabled then 
    if GroupSize <= 3 or Settings.TOverride then
        Target = TargetWindow()
    else
        ChatOutput("Target window disabled due to group size!")
    end
end
GCHandler = GarbageHandler()

MasterOptions = nil --OptionOptions()

InitiateHandlers()

if not(Settings.ReloadData) and ReloadStateData ~= nil and ReloadStateData.Note ~= nil and ReloadStateData.Note ~= "" then
    ChatOutput("<rgb=#004d00>Note window repopulated after restart, type /prime noteClear to clear the note window if this is needed.</rgb>")
end

if ReloadStateData ~= nil then
    if ReloadStateData.Note ~= nil then
    noteWindow.noteWindow:SetText(ReloadStateData.Note)
    end
    local cd = ReloadStateData.Countdown
    if ReloadStateData.Countdown ~= nil and cd > 0 then
        countdownWindow:Countdown(cd)
    end
end

--Sounds:PlaySoundEffect(SoundEffects["Alarmq"])

import "PrimePlugins.RaidTools.Options"
import "PrimePlugins.RaidTools.StatHandler"

Statwindow = nil --Stats()
SetTriggers()
SetCommands()
CreateSkillBarFromSave()

if Settings.ReloadData then 
    ChatOutput("<rgb=#FF9900>"..plugin:GetName() .. " Version " .. PluginVersion .." reloaded.</rgb>") 
else
    ChatOutput("<rgb=#FF9900>"..plugin:GetName() .. " Version " .. PluginVersion .." loaded.</rgb>") 
end

local greetingsMessage = Greetings[math.random(1, tablelength(Greetings))]
if Settings.EEnabled and not(Settings.ReloadData) then effectsWindow:Message(8, "<rgb=#0008CFF>".. greetingsMessage .. "</rgb>",nil,false) end
--effectsWindow:Message(3, "It's a dangerous business, Frodo, going out your door. You step onto the road, and if you don't keep your feet, there's no knowing where you might be swept off to.",nil,false)

--messageWindow:Message(5, "To enable sound effects you have to", nil, false)
--messageWindow:Message(5, "start logging your main chat window!", nil, false)

--[[
local backPack = Player:GetBackpack()

for i = 1, backPack:GetSize(), 1 do
    local item1 = backPack:GetItem(i)
    if item1 ~= nil then 
        local item = item1:GetItemInfo()
        ChatOutput(item:GetName() .. item:GetIconImageID()) 
    end
end
--]]

--[[
local effectList = Player:GetEffects()

local PlayerEffects = {}
for i = 1, effectList:GetCount(), 1 do
    PlayerEffects[effectList:Get(i):GetName()] = true
    ChatOutput(effectList:Get(i):GetName() .. " " .. effectList:Get(i):GetIcon())
end 
--]]
--for key, value in pairs(Turbine) do
--    ChatOutput(key)
--end

--[[
local tskills = Player:GetUntrainedSkills()

for i = 1, Player:GetUntrainedSkills():GetCount(), 1 do
    local item = tskills:GetItem(i)--:GetSkillInfo()
    ChatOutput(item:GetSkillInfo():GetName())

end
--]]

plugin.Unload = function() 
    SaveData()
    SaveLoot()
    SaveStats()
end

Settings.ReloadData = false