options = Turbine.UI.Control()
options:SetSize(500, 1580)

function GetWindowUI(parent, text, height, settingX, settingY)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(0, height)
    UIElement:SetSize(400, 35)

    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(20 , 0);
    UIElement.windowLabel:SetSize(200,15);
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    UIElement.windowLabel:SetVisible(true);
    UIElement.windowLabel:SetText(text);

    UIElement.windowX = Turbine.UI.TextBox()
    UIElement.windowX:SetParent(UIElement)
    UIElement.windowX:SetBackColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowX:SetForeColor(Turbine.UI.Color(0, 0, 0))
    UIElement.windowX:SetPosition(20 , 15);
    UIElement.windowX:SetSize(100,15);
    UIElement.windowX:SetText(settingX)
    UIElement.windowX:SetVisible(true);

    UIElement.windowY = Turbine.UI.TextBox()
    UIElement.windowY:SetParent(UIElement)
    UIElement.windowY:SetBackColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowY:SetForeColor(Turbine.UI.Color(0, 0, 0))
    UIElement.windowY:SetPosition(130 , 15);
    UIElement.windowY:SetSize(100,15);
    UIElement.windowY:SetText(settingY)
    UIElement.windowY:SetVisible(true);

    UIElement.button = Turbine.UI.Lotro.Button()
    UIElement.button:SetParent(UIElement)
    UIElement.button:SetPosition(240 , 10);
    UIElement.button:SetSize(100,15);
    UIElement.button:SetText("Apply change");
    UIElement.button:SetVisible(true);

    return(UIElement)
end

function GetLabelUI(parent, text, height)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(0, height)
    UIElement:SetSize(600, 30)
    -- NoteWindow
    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(20 , 0);
    UIElement.windowLabel:SetSize(600,30);
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana23);
    UIElement.windowLabel:SetVisible(true);
    UIElement.windowLabel:SetText(text);
    return(UIElement)
end

function GetCheckUI(parent, height, text, checked)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(20, height - 15)
    UIElement:SetSize(200, 40)

    UIElement.cBox = Turbine.UI.Lotro.CheckBox();
    UIElement.cBox:SetParent(UIElement)
    UIElement.cBox:SetPosition(15 , 0);
    UIElement.cBox:SetSize(300,40);
    UIElement.cBox:SetChecked(checked)
    UIElement.cBox:SetText(text);
    UIElement.cBox:SetVisible(true);
    return(UIElement)
end

function GetFontMenu(parent, height, text)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(20, height - 15)
    UIElement:SetSize(400, 50)

    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(0 , 10);
    UIElement.windowLabel:SetSize(200,15);
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    UIElement.windowLabel:SetVisible(true);
    UIElement.windowLabel:SetText("Change font");

    UIElement.menu = Turbine.UI.ContextMenu()
    UIElement.menuItems = UIElement.menu:GetItems()
    for i, fontName in pairs( Fonts ) do
        local menuItem = Turbine.UI.MenuItem( fontName )
        UIElement.menuItems:Add(menuItem)
        --ChatOutput(fontName)
     end

    UIElement.button = Turbine.UI.Lotro.Button()
    UIElement.button:SetParent(UIElement)
    UIElement.button:SetPosition(0, 30);
    UIElement.button:SetSize(200,15);
    UIElement.button:SetText(text);
    UIElement.button:SetVisible(true);

    UIElement.button.Click = function()
        UIElement.menu:ShowMenu()
    end

     return(UIElement)
end

Fonts = {}
FontsLUT = {}
FontsLUTR = {}
for key, item in pairs(Turbine.UI.Lotro.Font) do
    if ( item ~= "IsA" and item ~= "Undefined" ) then
        --ChatOutput("Key: " .. key .. " Value: " .. item)
        --Fonts[value] = key
       table.insert(Fonts, key)
       
       FontsLUT[key] = item
       FontsLUTR[item] = key

    end
 end
 table.sort(Fonts)

function GetOptionsBackground(Y, height, colour)
    local OptionsBackground = Turbine.UI.Control()
    OptionsBackground:SetParent(options)
    OptionsBackground:SetSize(500, height)
    OptionsBackground:SetPosition(0, Y)
    OptionsBackground:SetBackColor(colour)
end

function NoteWindowOptions(height) -- 70 height

    GetOptionsBackground(height, 70, Turbine.UI.Color(0, 0, 1))

    -- Note Window
    NoteWindowLabel = GetLabelUI(options, "Note Window Settings:", height) 

    NoteWindowOptions = GetWindowUI(options, "Width              Height", height + 30, Settings.NoteWidth, Settings.NoteHeight)
    NoteWindowOptions.button.Click = function()
        Settings.NoteWidth = NoteWindowOptions.windowX:GetText()
        Settings.NoteHeight = NoteWindowOptions.windowY:GetText()
        ReloadPlugin()
    end
end

Propaganda = class(Turbine.UI.Window)

function Propaganda:Constructor()
  Turbine.UI.Window.Constructor(self);
  local width = 800
  local height = 150
  local x = math.floor(Turbine.UI.Display.GetWidth() / 2 - (width /2))
  local y =  50
  local cooldownTimer = 0
  local maxFadeTimer = 5
  local fadeTimer = maxFadeTimer
  local maxTimer = 0
  local alertEffectName = ""

  self:SetSize(width,height);
  self:SetPosition(x,y);
  self:SetZOrder(1);

  self:SetWantsKeyEvents(false)
  self:SetMouseVisible(false)
  self:SetVisible(true)
  Updater:Subscribe(self)

  local messageTime = Turbine.Engine.GetGameTime() + math.random( 300)
  local showTime = 0

  --self:SetBackColor(GoldColor)

  local Label = Turbine.UI.Label()
  Label:SetParent(self)
  Label:SetSize(width, height)
  Label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  Label:SetMouseVisible(false)
  Label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
  Label:SetFontStyle(Turbine.UI.FontStyle.Outline)
  Label:SetMarkupEnabled(true)
  Label:SetOutlineColor(OutlineColor)
  Label:SetFontStyle( Turbine.UI.FontStyle.Outline )

  self.ExecuteUpdate = function(sender, delta)

    if showTime > 0 then
        showTime = showTime - delta
    else
        Label:SetVisible(false)
    end
    if Turbine.Engine.GetGameTime() > messageTime then
        Label:SetText(PropagandaMessages[math.random( Tablelength(PropagandaMessages) )])
        Label:SetVisible(true)
        showTime = 3
        messageTime = Turbine.Engine.GetGameTime() + math.random( 300, 600)
    end
  end
end

--P = Propaganda()


function EffectOptions(height)  -- 250 height

    GetOptionsBackground(height, 250, Turbine.UI.Color(0.5, 0, 1))
    
    -- Effect alerts
    EffectAlertLabel = GetLabelUI(options, "Effect Alert Settings:", height)

    EffectTestButton = Turbine.UI.Lotro.Button()
    EffectTestButton:SetParent(options)
    EffectTestButton:SetPosition(220, height);
    EffectTestButton:SetSize(100,15);
    EffectTestButton:SetText("Test alert");
    EffectTestButton:SetVisible(true);

    EffectTestButton.Click = function()
        if Settings.EEnabled then
            effectsWindow:Message(10, "<rgb="..GoldHex..">Test</rgb>", AlertIcon, true)
        end
    end

    EffectAlertCheckBox = GetCheckUI(options, height + 30, "Effect alerts enabled", Settings.EEnabled)
    EffectAlertCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.EEnabled = EffectAlertCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end

    EffectAlertOptions = GetWindowUI(options, "Window Width/Height", height + 50, Settings.EWidth, Settings.EHeight)
    EffectAlertOptions.button.Click = function()
        Settings.EWidth = EffectAlertOptions.windowX:GetText()
        Settings.EHeight = EffectAlertOptions.windowY:GetText()
        ReloadPlugin()
    end

    FontMenuEffect = GetFontMenu(options, height + 90, FontsLUTR[Settings.EFont]) 
    for i = 1, FontMenuEffect.menuItems:GetCount() do
        local menuItem = FontMenuEffect.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.EFont = FontsLUT[sender:GetText()]
            FontMenuEffect.button:SetText(Settings.EFont)
            ReloadPlugin()
        end
    end

    --EffectAlertLabel2 = GetLabelUI(options, "Icon size:", height + 130)
    --EffectWindowOptions2 = GetWindowUI(options, "Width              Height", height + 160, Settings.EIWidth, Settings.EIHeight)
    --EffectWindowOptions2.button.Click = function()
    --    Settings.EIWidth = EffectWindowOptions2.windowX:GetText()
    --    Settings.EIHeight = EffectWindowOptions2.windowY:GetText()
    --    ReloadPlugin()
    --end

    EffectAlertCheckBox2 = GetCheckUI(options, height + 200, "Left Icon Enabled", Settings.EL)
    EffectAlertCheckBox2.cBox.CheckedChanged = function(sender,args)
        Settings.EL = EffectAlertCheckBox2.cBox:IsChecked()
        ReloadPlugin()
    end
    EffectAlertCheckBox3 = GetCheckUI(options, height + 220, "Right Icon Enabled", Settings.ER)
    EffectAlertCheckBox3.cBox.CheckedChanged = function(sender,args)
        Settings.ER = EffectAlertCheckBox3.cBox:IsChecked()
        ReloadPlugin()
    end
end

function CountdownOptions(height) -- 110 height

    GetOptionsBackground(height, 110, Turbine.UI.Color(1, 0, 0))

    -- Countdown window
    CountDownLabel = GetLabelUI(options, "Count down Settings:", height)

    CountdownTestButton = Turbine.UI.Lotro.Button()
    CountdownTestButton:SetParent(options)
    CountdownTestButton:SetPosition(250, height);
    CountdownTestButton:SetSize(200,15);
    CountdownTestButton:SetText("Test countdown");
    CountdownTestButton:SetVisible(true);

    CountdownTestButton.Click = function()
        countdownWindow:Countdown(10)
    end

    CountdownWindowOptions = GetWindowUI(options, "CountdownWindow Width| Height", height + 30, Settings.CWidth, Settings.CHeight)
    CountdownWindowOptions.button.Click = function()
        Settings.CWidth = CountdownWindowOptions.windowX:GetText()
        Settings.CHeight = CountdownWindowOptions.windowY:GetText()
        ReloadPlugin()
    end

    FontMenuCountdown = GetFontMenu(options, height + 70, FontsLUTR[Settings.CFont]) 
    for i = 1, FontMenuCountdown.menuItems:GetCount() do
        local menuItem = FontMenuCountdown.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.CFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end
end

function MessageOptions(height) -- 290 height

    GetOptionsBackground(height, 290, Turbine.UI.Color(1, 0.4, 0.4))

    -- Message Window
    MessageWindowLabel = GetLabelUI(options, "Chat Alert Settings:", height)

    MessageTestButton = Turbine.UI.Lotro.Button()
    MessageTestButton:SetParent(options)
    MessageTestButton:SetPosition(220, height);
    MessageTestButton:SetSize(100,15);
    MessageTestButton:SetText("Test alert");
    MessageTestButton:SetVisible(true);
    
    MessageTestButton.Click = function()
        if Settings.MEnabled then
            messageWindow:Message(10, "Test", PuddleIconSmall, true)
        end
    end
    
    MessageWindowCheckBox = GetCheckUI(options, height + 40, "Chat alerts enabled", Settings.MEnabled)
    MessageWindowCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.MEnabled = MessageWindowCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end
    
    MessageWindowLabel2 = GetLabelUI(options, "Window size:", height + 60)
    MessageWindowOptions = GetWindowUI(options, "Width              Height", height + 80, Settings.MWidth, Settings.MHeight)
    MessageWindowOptions.button.Click = function()
        Settings.MWidth = MessageWindowOptions.windowX:GetText()
        Settings.MHeight = MessageWindowOptions.windowY:GetText()
        ReloadPlugin()
    end
    
    FontMenuMessage = GetFontMenu(options, height + 120, FontsLUTR[Settings.MFont]) 
    for i = 1, FontMenuMessage.menuItems:GetCount() do
        local menuItem = FontMenuMessage.menuItems:Get(i)
    
        menuItem.Click = function(sender, args)
            Settings.MFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end
    MessageWindowLabel3 = GetLabelUI(options, "Icon size:", height + 160)
    MessageWindowOptions2 = GetWindowUI(options, "Width              Height", height + 190, Settings.MIWidth, Settings.MIHeight)
    MessageWindowOptions2.button.Click = function()
        Settings.MIWidth = MessageWindowOptions2.windowX:GetText()
        Settings.MIHeight = MessageWindowOptions2.windowY:GetText()
        ReloadPlugin()
    end
    
    MessageWindowCheckBox2 = GetCheckUI(options, height + 230, "Left Icon Enabled", Settings.ML)
    MessageWindowCheckBox2.cBox.CheckedChanged = function(sender,args)
        Settings.ML = MessageWindowCheckBox2.cBox:IsChecked()
        ReloadPlugin()
    end
    MessageWindowCheckBox3 = GetCheckUI(options, height + 250, "Right Icon Enabled", Settings.MR)
    MessageWindowCheckBox3.cBox.CheckedChanged = function(sender,args)
        Settings.MR = MessageWindowCheckBox3.cBox:IsChecked()
        ReloadPlugin()
    end
    
end

function MessageOptions2(height) -- 290 height

    GetOptionsBackground(height, 290, Turbine.UI.Color(1, 0.4, 0.4))

    -- Message Window
    local MessageWindowLabel = GetLabelUI(options, "Chat / Other effects Alert Settings:", height)

    local MessageTestButton = Turbine.UI.Lotro.Button()
    MessageTestButton:SetParent(options)
    MessageTestButton:SetPosition(370, height);
    MessageTestButton:SetSize(100,15);
    MessageTestButton:SetText("Test alert");
    MessageTestButton:SetVisible(true);
    
    MessageTestButton.Click = function()
        if Settings.AEnabled then
            messageWindow:Message(math.random(10, 20), "Test on: oooooooooooooooooo", AlertIconSmall, true)
        end
    end
    
    local MessageWindowCheckBox = GetCheckUI(options, height + 40, "Chat alerts enabled", Settings.AEnabled)
    MessageWindowCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.AEnabled = MessageWindowCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end
    
    local MessageWindowLabel2 = GetLabelUI(options, "Window size:", height + 60)
    MessageWindowOptions = GetWindowUI(options, "Width              Height", height + 80, Settings.AWidth, Settings.AHeight)
    MessageWindowOptions.button.Click = function()
        Settings.AWidth = MessageWindowOptions.windowX:GetText()
        Settings.AHeight = MessageWindowOptions.windowY:GetText()
        ReloadPlugin()
    end

    local MessageWindowLabel2 = GetLabelUI(options, "Window Position:", height + 160)
    MessageWindowOptions = GetWindowUI(options, "X              Y", height + 180, Settings.AX, Settings.AY)
    MessageWindowOptions.button.Click = function()
        Settings.AX = MessageWindowOptions.windowX:GetText()
        Settings.AY = MessageWindowOptions.windowY:GetText()
        messageWindow:SetPosition(Settings.AX, Settings.AY)
        ReloadPlugin()
    end
    
    local FontMenuMessage = GetFontMenu(options, height + 120, FontsLUTR[Settings.AFont]) 
    for i = 1, FontMenuMessage.menuItems:GetCount() do
        local menuItem = FontMenuMessage.menuItems:Get(i)
    
        menuItem.Click = function(sender, args)
            Settings.AFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end
    --MessageWindowLabel3 = GetLabelUI(options, "Icon size:", height + 160)
    --MessageWindowOptions2 = GetWindowUI(options, "Width              Height", height + 190, Settings.AIWidth, Settings.AIHeight)
    --MessageWindowOptions2.button.Click = function()
    --    Settings.AIWidth = MessageWindowOptions2.windowX:GetText()
    --    Settings.AIHeight = MessageWindowOptions2.windowY:GetText()
    --    ReloadPlugin()
    --end
    
    local MessageWindowCheckBox2 = GetCheckUI(options, height + 230, "Left Icon Enabled", Settings.AL)
    MessageWindowCheckBox2.cBox.CheckedChanged = function(sender,args)
        Settings.AL = MessageWindowCheckBox2.cBox:IsChecked()
        ReloadPlugin()
    end
    local MessageWindowCheckBox3 = GetCheckUI(options, height + 250, "Right Icon Enabled", Settings.AR)
    MessageWindowCheckBox3.cBox.CheckedChanged = function(sender,args)
        Settings.AR = MessageWindowCheckBox3.cBox:IsChecked()
        ReloadPlugin()
    end
    
end

function SkillCounterOptions(height) -- 210 height

    GetOptionsBackground(height, 210, Turbine.UI.Color(0.1, 0.1, 0.1))

    -- SkillCounter (Enemies)
    SkillCounterLabel = GetLabelUI(options, "Skill Alert Settings:", height)

    SkillCounterTestButton = Turbine.UI.Lotro.Button()
    SkillCounterTestButton:SetParent(options)
    SkillCounterTestButton:SetPosition(220, height);
    SkillCounterTestButton:SetSize(100,15);
    SkillCounterTestButton:SetText("Test timer");
    SkillCounterTestButton:SetVisible(true);

    SkillCounterTestButton.Click = function()
        if Settings.SEnabled then
            skillCounters:NewTimer(15, "Test")
        end
    end

    SkillCounterCheckBox = GetCheckUI(options, height + 40, "Enemy skill timers enabled", Settings.SEnabled)
    SkillCounterCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.SEnabled = SkillCounterCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end

    SkillCountersOptions = GetWindowUI(options, "Width              Height", height + 80, Settings.SNewWidth, Settings.SNewHeight)
    SkillCountersOptions.button.Click = function()
        Settings.SNewWidth = SkillCountersOptions.windowX:GetText()
        Settings.SNewHeight = SkillCountersOptions.windowY:GetText()
        ReloadPlugin()
    end

    FontMenuSkillCounter = GetFontMenu(options, height + 130, FontsLUTR[Settings.SNewFont]) 
    for i = 1, FontMenuSkillCounter.menuItems:GetCount() do
        local menuItem = FontMenuSkillCounter.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.SNewFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end

    SkillCountersOptions2 = GetWindowUI(options, "Timer Width/Height", height + 170, Settings.SNewWidth, Settings.SNewTimer)
    SkillCountersOptions2.button.Click = function()
        Settings.SNewWidth = SkillCountersOptions2.windowX:GetText()
        Settings.SNewTimer = SkillCountersOptions2.windowY:GetText()
        ReloadPlugin()
    end
end

function SkillTimerOptions(height) -- 220 height

    GetOptionsBackground(height, 220, Turbine.UI.Color(0, 0.5, 0.5))

    -- Skill timers (Players)
    SkillTimerLabel = GetLabelUI(options, "Player Skill Alert Settings:", height)

    SkillTimerTestButton = Turbine.UI.Lotro.Button()
    SkillTimerTestButton:SetParent(options)
    SkillTimerTestButton:SetPosition(280, height);
    SkillTimerTestButton:SetSize(100,15);
    SkillTimerTestButton:SetText("Test timer");
    SkillTimerTestButton:SetVisible(true);

    SkillTimerTestButton.Click = function()
        if Settings.SPEnabled then
            skillTimers:NewTimer(15, "Test", "Test", false, 5, false, TyrantIcon, "Test")
            activeTimers:NewTimer(15, "Test", "Test", false, 5, true, TyrantIcon, "Test")
        end
    end

    SkillTimerCheckBox = GetCheckUI(options, height + 30, "Player timers enabled", Settings.SPEnabled)
    SkillTimerCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.SPEnabled = SkillTimerCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end

    SkillTimerOptions = GetWindowUI(options, "Width              Height", height + 70, Settings.SPWidth2, Settings.SPHeight2)
    SkillTimerOptions.button.Click = function()
        Settings.SPWidth2 = SkillTimerOptions.windowX:GetText()
        Settings.SPHeight2 = SkillTimerOptions.windowY:GetText()
        ReloadPlugin()
    end

    FontMenuSkillTimer = GetFontMenu(options, height + 120, FontsLUTR[Settings.SPNewFont]) 
    for i = 1, FontMenuSkillTimer.menuItems:GetCount() do
        local menuItem = FontMenuSkillTimer.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.SPNewFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end

    --SkillTimersOptions2 = GetWindowUI(options, "Timer Width/Height", height + 170, Settings.SPTimerWidth, Settings.SPTimerHeight)
    --SkillTimersOptions2.button.Click = function()
    --    Settings.SPTimerWidth = SkillTimersOptions2.windowX:GetText()
    --    Settings.SPTimerHeight = SkillTimersOptions2.windowY:GetText()
    --    ReloadPlugin()
    --end
    SkillTimerCheckBox2 = GetCheckUI(options, height + 170, "Player timers active enabled", Settings.SPAEnabled)
    SkillTimerCheckBox2.cBox.CheckedChanged = function(sender,args)
        Settings.SPAEnabled = SkillTimerCheckBox2.cBox:IsChecked()
        ReloadPlugin()
    end
end

function CombatTimerOptions(height) -- 150 height

    GetOptionsBackground(height, 150, Turbine.UI.Color(0.5, 0.5, 0.5))

    -- Combat timer window
    CombatTimerLabel = GetLabelUI(options, "Combat timer window Settings:", height)

    CombatTimerCheckBox = GetCheckUI(options, height + 40, "Combat timer enabled", Settings.CTEnabled)
    CombatTimerCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.CTEnabled = CombatTimerCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end

    CombatTimerWindowOptions = GetWindowUI(options, " Width| Height", height + 70, Settings.CTWidth, Settings.CTHeight)
    CombatTimerWindowOptions.button.Click = function()
        Settings.CTWidth = CombatTimerWindowOptions.windowX:GetText()
        Settings.CTHeight = CombatTimerWindowOptions.windowY:GetText()
        ReloadPlugin()
    end

    FontMenuCombatTimer = GetFontMenu(options, height + 110, FontsLUTR[Settings.CTFont]) 
    for i = 1, FontMenuCombatTimer.menuItems:GetCount() do
        local menuItem = FontMenuCombatTimer.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.CTFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end
end

function LeaderWindowOptions(height) -- 70 height

    GetOptionsBackground(height, 70, Turbine.UI.Color(0, 0, 0))

    -- Leader window
    LeaderWindowLabel = GetLabelUI(options, "Leader window Settings:", height)

    LeaderWindowCheckbox = GetCheckUI(options, height + 30, "Leader window enabled", Settings.LWEnabled)
    LeaderWindowCheckbox.cBox.CheckedChanged = function(sender,args)
        Settings.LWEnabled = LeaderWindowCheckbox.cBox:IsChecked()
        ReloadPlugin()
    end
end

function LogWindowOptions(height) -- 70 height

    GetOptionsBackground(height, 70, Turbine.UI.Color(0.5, 0.5, 0))

    -- Log window
    LogWindowLabel = GetLabelUI(options, "Log window Settings:", height)

    LogWindowCheckbox = GetCheckUI(options, height + 30, "Log window enabled", Settings.LEnabled)
    LogWindowCheckbox.cBox.CheckedChanged = function(sender,args)
        Settings.LEnabled = LogWindowCheckbox.cBox:IsChecked()
        ReloadPlugin()
    end
end

function RatTrackerOptions(height)
    GetOptionsBackground(height, 70, Turbine.UI.Color(0, 0, 1))

    -- Log window
    RatTrackerLabel = GetLabelUI(options, "Rat tracker Settings:", height)

    RatTrackerCheckbox = GetCheckUI(options, height + 30, "Rat tracker enabled", Settings.REnabled)
    RatTrackerCheckbox.cBox.CheckedChanged = function(sender,args)
        Settings.REnabled = RatTrackerCheckbox.cBox:IsChecked()
        ReloadPlugin()
    end
end

function ResetLabelOptions(height) -- 70 height

    GetOptionsBackground(height, 70, Turbine.UI.Color(0, 0, 0))

    -- Reset to default settings
    ResetLabel = GetLabelUI(options, "Reset to Default Settings:", height)

    ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(options)
    ResetButton:SetPosition(20, height + 30);
    ResetButton:SetSize(100,15);
    ResetButton:SetText("Reset");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        Settings.Reload = true
        ReloadPlugin()
    end
end

NoteWindowOptions(0) -- 70 height
EffectOptions(70) -- 250 height
CountdownOptions(320) -- 110 height
MessageOptions2(430) -- 290 height
SkillCounterOptions(720) -- 210 height
SkillTimerOptions(930) -- 220 height
CombatTimerOptions(1150) -- 150 height
LeaderWindowOptions(1300) -- 70 height
LogWindowOptions(1370) -- 70 height
--RatTrackerOptions(1440) -- 70 height
ResetLabelOptions(1440) -- 70 height

plugin.GetOptionsPanel = function( self )
    return options;
end

function SetCommands()
    Command = Turbine.ShellCommand()

    function Command:Execute( _, command )
        if command ~= nil or string.len( command ) ~= 0 then
            if command == "options" then
                ChatOutput("X")
            elseif command == "reload" then
                ReloadPlugin()
            elseif command == "move" then
                MoveWindow(true)
            elseif command == "lock" then
                MoveWindow(false)
            elseif command == "help" then
                ChatOutput(HelpString)
            elseif command == "loot" then
                if Settings.LOEnabled then lootWindow:SetVisible(not(lootWindow:IsVisible())) end 
            elseif command == "dungeon" then
                if DungeonWindow ~= nil then DungeonWindow:SetVisible(not(DungeonWindow:IsVisible())) end 
            elseif command == "features" then
                ChatOutput(Features)
            elseif command == "reset" then
                GetDefaultSettings()
                ReloadPlugin()
            elseif command == "clear" then
                ClearUI()
            elseif command == "time" then
                ChatOutput("Beginning of Prime time: " .. BeginningOfPrimeTime)
            elseif command == "soundtest" then
                Sounds:PlaySoundEffect(SoundEffects["Test"])
            elseif command == "ready" then
                if Party ~= nil then
                    if Party:GetLeader():GetName() == Player:GetName() then
                        RCButtonWindow:SetVisible(true)
                    end
                else
                    ChatOutput("You are not in a party!")
                end
            elseif command == "party" then
                if Party ~= nil then
                    if not(ReadyCheck:IsVisible()) then
                        ReadyCheck:SetVisible(true)
                        ReadyCheck:MakeNewReadyCheck()
                    end
                else
                    ChatOutput("You are not in a party!")
                end
            elseif command == "noteClear" then
                noteWindow.noteWindow:SetText("")
            elseif string.find(command, "AddSwap") and string.sub(command, 0, 8) == "AddSwap " then
                SwappyWarner:AddSwapWeapon(string.sub(command, 9, string.len(command)))
                ReloadPlugin()
            elseif string.find(command, "RemoveSwap") and string.sub(command, 0, 11) == "RemoveSwap "then
                SwappyWarner:RemoveSwapWeapon(string.sub(command, 12, string.len(command)))
                ReloadPlugin()
            elseif command == "ListSwaps" then
                SwappyWarner:PrintSwaps()
            elseif command == "ListEquipment" then
                SwappyWarner:ListEquipment()
            else
                ChatOutput( "Non-existing command" )
            end
        end
    end
    
    Turbine.Shell.AddCommand( "prime", Command )
end