OptionsButton=class(Turbine.UI.Window) 

function OptionsButton:Constructor()
    Turbine.UI.Window.Constructor(self);
    self:SetSize(120, 20);
    self:SetPosition(Settings.OX, Settings.OY);
    self:SetVisible(true)
    
    self.toggleButton = Turbine.UI.Lotro.Button()
    self.toggleButton:SetParent(self)
    self.toggleButton:SetText("Options")
    self.toggleButton:SetVisible(true)
    self.toggleButton:SetSize(120, 20)

    local menu = Turbine.UI.ContextMenu()
    local menuItems = menu:GetItems()

    local toggleMenu = Turbine.UI.ContextMenu()
    local toggleMenuItems = toggleMenu:GetItems()

    -- TOGGLE MENU

    -- Note window
    local noteItem = Turbine.UI.MenuItem( "Note Window" )
    toggleMenuItems:Add(noteItem)
    noteItem.Click = function(sender, args)
        noteWindow:SetVisible(not noteWindow:IsVisible())
    end

    -- Leader Window
    if Settings.LWEnabled then
        local leaderItem = Turbine.UI.MenuItem("Leader Window")
        toggleMenuItems:Add(leaderItem)

        leaderItem.Click = function(sender, args)
            leaderWindow:SetVisible(not leaderWindow:IsVisible())
        end
    end

    -- Log Window
    if Settings.LEnabled then
        local logItem = Turbine.UI.MenuItem("Log Window")
        toggleMenuItems:Add(logItem)

        logItem.Click = function(sender, args)
            logWindow:SetVisible(not logWindow:IsVisible())
        end
    end

    -- Skill Window
    if tablelength(SkillAlerts.PlayerEffects[Player:GetClass()]) > 0 then
        local skillItem = Turbine.UI.MenuItem("Skill Window")
        toggleMenuItems:Add(skillItem)

        skillItem.Click = function(sender, args)
            skillWindow:SetVisible(not skillWindow:IsVisible())
        end
    end
    
    -- Scroll Window
    local ScrollWindow = Turbine.UI.MenuItem("Party Window")
    toggleMenuItems:Add(ScrollWindow)
    ScrollWindow.Click = function()
        if Party ~= nil then
            if not(ReadyCheck:IsVisible()) then
                ReadyCheck:SetVisible(true)
                ReadyCheck:MakeNewReadyCheck()
            end
        else
            ChatOutput("You are not in a party!")
        end
    end

    -- Close menu
    local toggleCloseItem = Turbine.UI.MenuItem("Close")
    toggleMenuItems:Add(toggleCloseItem)
    toggleCloseItem.Click = function(sender, args)
        toggleMenu:Close()
    end

    --MAIN MENU
    
    -- Reload plugin
    local reloadItem = Turbine.UI.MenuItem( "Reload plugin" )
    menuItems:Add(reloadItem)

    reloadItem.Click = function()
        if reloadWindow ~= nil then
            reloadWindow:SetVisible(not(reloadWindow:IsVisible()))
        end
        if reloadWindow:IsVisible() then
            reloadWindow:SetZOrder(1)
        end
    end

    local toggleMenuItem = Turbine.UI.MenuItem("Toggle menu")
    menuItems:Add(toggleMenuItem)
    toggleMenuItem.Click = function()
        toggleMenu:ShowMenu()
    end

    local toggleMenuItem = Turbine.UI.MenuItem("Clear Timers")
    menuItems:Add(toggleMenuItem)
    toggleMenuItem.Click = function()
        ClearUI()
    end

    local toggleMenuItem = Turbine.UI.MenuItem("Clear Countdown")
    menuItems:Add(toggleMenuItem)
    toggleMenuItem.Click = function()
        countdownWindow:Countdown(-1)
    end

    local toggleMenuItem = Turbine.UI.MenuItem("Master Options")
    menuItems:Add(toggleMenuItem)
    toggleMenuItem.Click = function()
        if MasterOptions == nil then
            MasterOptions = OptionOptions()
        else
            MasterOptions:SetVisible(not(MasterOptions:IsVisible()))
        end
    end

    local toggleMenuItem = Turbine.UI.MenuItem("Stats")
    menuItems:Add(toggleMenuItem)
    toggleMenuItem.Click = function()
        if Statwindow == nil then
            Statwindow = Stats()
        else
            Statwindow:SetVisible(not(Statwindow:IsVisible()))
        end
    end
    
    -- Loot Window
    if Settings.LOEnabled then
        local lootItem = Turbine.UI.MenuItem("Loot Window")
        menuItems:Add(lootItem)

        lootItem.Click = function(sender, args)
            lootWindow:SetVisible(not lootWindow:IsVisible())
            if lootWindow:IsVisible() then
                lootWindow:SetZOrder(1)
            end
        end
    end


    -- Rat Tracker
    --if Settings.REnabled then
    --    local ratItem = Turbine.UI.MenuItem( "Toggle Rat Tracker")
    --    menuItems:Add(ratItem)

    --    ratItem.Click = function(sender, args)
    --        ratTracker:SetVisible(not ratTracker:IsVisible())
    --    end
    --end

    -- Dungeon log
    local dungeonItem = Turbine.UI.MenuItem("Dungeon Log")
    menuItems:Add(dungeonItem)
    dungeonItem.Click = function()
        if DungeonWindow == nil then
            DungeonWindow = DungeonLog()
        end
        DungeonWindow:SetVisible(not(DungeonWindow:IsVisible()))
    end

    local ReadyCheckItem = Turbine.UI.MenuItem("Ready Check")
    menuItems:Add(ReadyCheckItem)
    ReadyCheckItem.Click = function()
        if Party ~= nil then
            if Party:GetLeader():GetName() == Player:GetName() or SpecialNames[Player:GetName()]  then
                RCButtonWindow:SetVisible(not(RCButtonWindow:IsVisible()))
            else
                ChatOutput("You are not the party leader!")
            end
        else
            ChatOutput("You are not in a party!")
        end
    end

    local ReloadItem = Turbine.UI.MenuItem("Force Reload")
    menuItems:Add(ReloadItem)
    ReloadItem.Click = function()
        if Party ~= nil then
            if Party:GetLeader():GetName() == Player:GetName() or SpecialNames[Player:GetName()] then
                RButton:SetVisible(not(RButton:IsVisible()))
            else
                ChatOutput("You are not the party leader!")
            end
        else
            ChatOutput("You are not in a party!")
        end
    end

    -- Move Windows
    local moveActionItem = Turbine.UI.MenuItem("Move Action Bars")
    menuItems:Add(moveActionItem)

    moveActionItem.Click = function(sender, args)
        if moveActionItem:GetText() == "Move Action Bars" then
            moveActionItem:SetText("Lock Action Bars")
        else
            moveActionItem:SetText("Move Action Bars")
        end
        MoveActionBars()
    end

    -- Move Windows
    local moveItems = Turbine.UI.MenuItem("Move Windows")
    menuItems:Add(moveItems)

    moveItems.Click = function(sender, args)
        local mode = false
        if moveItems:GetText() == "Move Windows" then
            moveItems:SetText("Lock Windows")
            mode = true
        else
            moveItems:SetText("Move Windows")
        end
        MoveWindow(mode)
    end

    -- Close menu
    local closeItem = Turbine.UI.MenuItem("Close")
    menuItems:Add(closeItem)
    closeItem.Click = function(sender, args)
        menu:Close()
    end

    -- Plugin Options
    --local pluginOptionsItem = Turbine.UI.MenuItem("Open Plugin Options")
    --menuItems:Add(pluginOptionsItem)
    --pluginOptionsItem.Click = function(sender, args)
    --    Turbine.PluginManager.ShowOptions(plugin)
    --end

    

    self.toggleButton.Click = function()
        menu:ShowMenu()
    end

    self.Moving = false

    self.toggleButton.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.toggleButton.MouseUp = function()
        self.Moving = false
    end

    self.toggleButton.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          if newLeft < 0 then newLeft = 0 end
          if newTop < 0 then newTop = 0 end
          if newLeft > (Turbine.UI.Display.GetWidth() - self:GetWidth()) then
            newLeft = Turbine.UI.Display.GetWidth() - self:GetWidth() end
          if newTop > (Turbine.UI.Display.GetHeight() - self:GetHeight()) then
            newTop = Turbine.UI.Display.GetHeight() - self:GetHeight() end
          self:SetPosition(newLeft,newTop)
        end
    end
end

function MoveWindow(mode)
    noteWindow:ToggleMove();
    countdownWindow:ToggleMove();
    if Target ~= nil then Target:ToggleMove() end
    --if Settings.REnabled then ratTracker:ToggleMove(); end
    if Settings.AEnabled then messageWindow:ToggleMove(); end
    if Settings.EEnabled then effectsWindow:ToggleMove(); end
    if Settings.SEnabled then skillCounters:ToggleMove(); end
    if Settings.LEnabled then logWindow:ToggleMove(); end
    if Settings.CTEnabled then combatTimer:ToggleMove(); end
    if Settings.SPEnabled then skillTimers:ToggleMove(); end
    if Settings.SPEnabled then activeTimers:ToggleMove(); end
    if tablelength(SkillAlerts.PlayerEffects[Player:GetClass()]) > 0 then skillWindow:ToggleMove(); end
    if(mode) then
        if(not noteWindow:IsVisible()) then
            noteWindow:SetVisible(not noteWindow:IsVisible())
        end
        if Settings.LEnabled then 
            if(not logWindow:IsVisible())then
                logWindow:SetVisible(not logWindow:IsVisible())
            end
        end
    else
        if(noteWindow:IsVisible()) then
            noteWindow:SetVisible(false)
        end
        if Settings.LEnabled then
            if(logWindow:IsVisible())then
                logWindow:SetVisible(false)
            end
        end
    end
end

function MoveActionBars()
    for _, value in pairs(ActiveSkillBars) do
        value:ToggleMove()
    end
end


ReloadWindow = class(Turbine.UI.Lotro.Window)
function ReloadWindow:Constructor()
    Turbine.UI.Lotro.Window.Constructor(self);
    local width = 400
    local height = 150
    self:SetSize(width,height);
    self:SetPosition( math.floor(Turbine.UI.Display.GetWidth() / 2 - (width/2)), math.floor(Turbine.UI.Display.GetHeight() / 2 - (height /2) - 2));
    self:SetWantsKeyEvents(true)
    self:SetText("Reload")
    self:SetVisible(false)
    self:SetZOrder(1)

    self.confirmLabel = Turbine.UI.Label()
    self.confirmLabel:SetVisible(true)
    self.confirmLabel:SetFont(labelFont)
    self.confirmLabel:SetText("Are you sure you want to reload the plugin?")
    self.confirmLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.confirmLabel:SetParent(self)
    self.confirmLabel:SetSize(400, 40)
    self.confirmLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.confirmLabel:SetPosition(0, 40)

    self.reloadButton = Turbine.UI.Lotro.Button()
    --self.reloadButton:SetPosition(self:GetWidth()/3*2 - self.clearButton:GetWidth()/2, 160)
    self.reloadButton:SetText("Yes [Enter]")
    self.reloadButton:SetWidth(100)
    self.reloadButton:SetParent(self)
    self.reloadButton:SetPosition(100, 100)

    self.reloadButton.Click = function()
        ReloadPlugin()
    end

    self.cancelButton = Turbine.UI.Lotro.Button()
    --self.cancelButton:SetPosition(self:GetWidth()/3*2 - self.clearButton:GetWidth()/2, 160)
    self.cancelButton:SetText("No [ESC]")
    self.cancelButton:SetWidth(100)
    self.cancelButton:SetParent(self)
    self.cancelButton:SetPosition(200, 100)

    self.cancelButton.Click = function()
        self:SetVisible(false)
    end

    self.KeyDown = function(sender, args)
        if self:IsVisible() then
            if args["Action"] == 145 then
                if self:IsVisible() then self:SetVisible(false) end
            elseif args["Action"] == 162 then
                ReloadPlugin()
            end
        end
    end

end


ReloadButton = class(Turbine.UI.Window)
function ReloadButton:Constructor()
    local buttonUpdate = Turbine.Engine.GetGameTime()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(32, 32)
    --self:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self:SetVisible(false)
    self:SetPosition(math.floor( Turbine.UI.Display.GetWidth() / 2 - 16), math.floor( Turbine.UI.Display.GetHeight() / 2 - 16))
    self:SetMouseVisible(true)
    self:SetWantsKeyEvents(true)
    --self:SetWantsUpdates(true)

    self.readyButton = Turbine.UI.Lotro.Quickslot()
    self.readyButton:SetParent(self)
    self.readyButton:SetUseOnRightClick(false)
    self.readyButton:SetShortcut()
    self.readyButton:SetParent(self)
    self.readyButton:SetMouseVisible(true)
    self.readyButton:SetWantsKeyEvents(true)
    self.readyButton:SetSize(32, 32)
    self.readyButton:SetWantsUpdates(true)

    self.VisibleChanged = function()
        if Party ~= nil then 
            local channel = "f"
            if Party:GetMemberCount() > 6 then
                channel = "ra"
            end
            self.readyButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. channel .. " " .. " Force Reload"))
        end
    end


end