OptionOptions = class(Turbine.UI.Lotro.Window)
function OptionOptions:Constructor()
    local width = Settings.LOWidth
    local height = 600
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Lotro.Window.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(x,y);
    self:SetWantsKeyEvents(true)
    self:SetText("Option Options")
    self:SetVisible(true)

    OptionsDic = {} 

    TargetOptionWindow = TargetWindowOptions(self)
    OptionsDic[TargetOptionWindow] = true

    SkillOverlayOptionsWindow = SkillOverlayOptions(self)
    OptionsDic[SkillOverlayOptionsWindow] = true

    SkillOptions = SkillTimerSettings(self)
    OptionsDic[SkillOptions] = true

    EffectOptionsWindow = EffectAlertSettings(self)
    OptionsDic[EffectOptionsWindow] = true

    ChatOptionsWindow = ChatAlertSettings(self)
    OptionsDic[ChatOptionsWindow] = true

    LootOptions = LootWindowSettings(self)
    OptionsDic[LootOptions] = true

    local menu = Turbine.UI.ContextMenu()
    local menuItems = menu:GetItems()

    local menuItem = Turbine.UI.MenuItem( "Target Window" )
    menuItems:Add(menuItem)
    menuItem.Click = function()
        for key, _ in pairs(OptionsDic) do
            key:SetVisible(false)
        end
        TargetOptionWindow:SetVisible(true)
        self:SetText(menuItem:GetText())
    end

    local menuItem = Turbine.UI.MenuItem( "Skill Overlay" )
    menuItems:Add(menuItem)
    menuItem.Click = function()
        for key, _ in pairs(OptionsDic) do
            key:SetVisible(false)
        end
        SkillOverlayOptionsWindow:SetVisible(true)
        self:SetText(menuItem:GetText())
    end

    local menuItem = Turbine.UI.MenuItem( "Skill Timers" )
    menuItems:Add(menuItem)
    menuItem.Click = function()
        for key, _ in pairs(OptionsDic) do
            key:SetVisible(false)
        end
        SkillOptions:SetVisible(true)
        self:SetText(menuItem:GetText())
    end

    local menuItem = Turbine.UI.MenuItem( "Effect Alerts" )
    menuItems:Add(menuItem)
    menuItem.Click = function()
        for key, _ in pairs(OptionsDic) do
            key:SetVisible(false)
        end
        EffectOptionsWindow:SetVisible(true)
        self:SetText(menuItem:GetText())
    end

    local menuItem = Turbine.UI.MenuItem( "Chat Alerts" )
    menuItems:Add(menuItem)
    menuItem.Click = function()
        for key, _ in pairs(OptionsDic) do
            key:SetVisible(false)
        end
        ChatOptionsWindow:SetVisible(true)
        self:SetText(menuItem:GetText())
    end

    local menuItem = Turbine.UI.MenuItem( "Loot" )
    menuItems:Add(menuItem)
    menuItem.Click = function()
        for key, _ in pairs(OptionsDic) do
            key:SetVisible(false)
        end
        LootOptions:SetVisible(true)
        self:SetText(menuItem:GetText())
    end


    local AllButton = Turbine.UI.Lotro.Button()
    AllButton:SetParent(self)
    AllButton:SetSize(200, 15)
    AllButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    AllButton:SetMouseVisible(true)
    AllButton:SetPosition(270, 50)
    AllButton:SetText("Select Options")

    AllButton.Click = function()
        menu:ShowMenu()
    end



end