SkillCounters = class(Turbine.UI.Window)
function SkillCounters:Constructor()
    local width = Settings.SNewWidth
    local height = Settings.SNewHeight
    local x = Settings.SX2
    local y = Settings.SY2
    local cooldownTimer = 0
    local oldGameTime = Turbine.Engine.GetGameTime()
    local Timers = {}
    local ID = 0
    local resort = false
    Turbine.UI.Window.Constructor(self);
    self:SetSize(width,height);
    self:SetPosition(x,y);
    self:SetZOrder(1);

    self:SetWantsKeyEvents(true)
    self:SetMouseVisible(false)
    self:SetVisible(true)
    --self:SetWantsUpdates(true)
    --Updater:Subscribe(self)

    self.messageBox = Turbine.UI.Label()
    self.messageBox:SetParent(self)
    self.messageBox:SetSize(width,height)
    self.messageBox:SetPosition(0,0)
    self.messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox:SetFont(Settings.SFont)
    self.messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox:SetMouseVisible(false)
    self.messageBox:SetVisible(false)
  
    local moveBox = MoveBox(self, width, height, "Boss CDs")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.ExecuteUpdate = function(sender, delta)    
        --We had an update
        for key, value in pairs(Timers) do 
            --ChatOutput(value[2])
            value[2] = value[2] - delta
            value[1]:UpdateText(delta)
            if value[2] < 0 then 
                value[1]:Destroy()
                Timers[key] = nil
                resort = true
            end
            --value[1]:SetText(value[3].." "..value[2])
        end
        if resort then 
            if tablelength(Timers) == 0 then 
                Updater:UnSubscribe(self) 
                Timers = nil
                collectgarbage()
                Timers = {}
                return
            end
            self.ResortList() 
        end
    end
    -- Add a timer
    self.NewTimer = function(sender, duration, message)
        local count = tablelength(Timers)
        --Timers[ID] =  {Counter(self, width, height, count, duration, message), duration, message}
        Timers[#Timers + 1] = {Counter2(self, width, Settings.SNewTimer, count, duration, message, Settings.SNewFont, Turbine.UI.Color(1,0,0), Turbine.UI.Color(0.5,0,0), Turbine.UI.Color(0,0.125,0.5), Turbine.UI.Color(0,0.6,7), Turbine.UI.Color(0,0.0,0.8), nil, nil), duration, message}
        --ID = ID + 1
        resort = true
        Updater:Subscribe(self)
        --PrintTable(Timers)
    end

    self.Clear = function()
        for key, value in pairs(Timers) do 
            value[1]:Destroy()
            Timers[key] = nil
            --table.remove(Timers, key )
            --PrintTable(Timers)
        end
    
        if Tablelength(Timers) > 0 then
            self.Clear()
        end
        Timers = nil
        collectgarbage()
        Timers = {}
    end

    self.ResortList = function()
        if Tablelength(Timers) > 1 then  
            table.sort(Timers, Compare)
        end
        local counter = 0
        for key, value in pairs(Timers) do
            value[1]:SetPosition(0, counter * Settings.SNewTimer) 
            counter = counter + 1
        end

        resort = false
    end
end
