SkillOverlayOptions = class(Turbine.UI.Control)
function SkillOverlayOptions:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetParent(parent)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(0,75);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local menu = Turbine.UI.ContextMenu()
    local menuItems = menu:GetItems()

    local tskills = Player:GetTrainedSkills()
    local counter = 0

    local currentlySelectedItem = nil
    local SkillDictionary = {}
    local LocalSkillBars = {}
    local SkillsByNames = {}

    local itemSelectedLabel = Turbine.UI.Label()
    itemSelectedLabel:SetParent(self)
    itemSelectedLabel:SetSize(30, 30)
    itemSelectedLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    itemSelectedLabel:SetMouseVisible(false)
    itemSelectedLabel:SetPosition(60, 100)

    local skillSelected = Turbine.UI.Label()
    skillSelected:SetParent(self)
    skillSelected:SetSize(100, 30)
    skillSelected:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    skillSelected:SetMouseVisible(false)
    skillSelected:SetPosition(220, 100)

    local removeLabel = Turbine.UI.Label()
    removeLabel:SetSize(250, 40)
    removeLabel:SetPosition(500, 50)
    removeLabel:SetParent(self)
    removeLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    removeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    removeLabel:SetOutlineColor(OutlineColor)
    removeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    removeLabel:SetForeColor(Turbine.UI.Color(1, 0,0))
    removeLabel:SetVisible(false)
    removeLabel:SetText("Have patience and reload the plugin to reflect udpates")

    for i = 1, Player:GetTrainedSkills():GetCount(), 1 do
        local item = tskills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName() 
        local description = item:GetSkillInfo():GetDescription()

        if (not(RealSkill(description))and string.len(description) > 0 and item:GetSkillInfo():GetType() ~= 1) then
            SkillsByNames[name] = item
        end
    end

    local sortedKeys = {}
    for key, value in pairs(SkillsByNames) do table.insert( sortedKeys, key ) end
    table.sort( sortedKeys )
    
    for key, name in pairs(sortedKeys) do
        local item = SkillsByNames[name]
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            if currentlySelectedItem ~= nil then
               skillSelected:SetText(name) 
               SkillDictionary[tonumber(currentlySelectedItem:GetText())] = item
               currentlySelectedItem:SetBackColor()
               currentlySelectedItem:SetBackground(item:GetSkillInfo():GetIconImageID())
            end
        end
        
        menuItems:Add(menuItem)
    end

    local nilItem = Turbine.UI.MenuItem( "No Skill" )
    nilItem.Click = function()
        if currentlySelectedItem ~= nil then
           skillSelected:SetText("") 
           SkillDictionary[tonumber(currentlySelectedItem:GetText())] = ""
           currentlySelectedItem:SetBackColor(GetRandomColour())
        end
    end
    menuItems:Add(nilItem)
    

    self.MakeSkillBox = function(index)
        local skillLabel = Turbine.UI.Label()
        skillLabel:SetParent(self)
        skillLabel:SetPosition(30 + 35 * index, 50)
        skillLabel:SetSize(32, 32)
        skillLabel:SetText(index)
        skillLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        skillLabel:SetBackColor(GetRandomColour())
        skillLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        skillLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        skillLabel:SetOutlineColor(OutlineColor)
        SkillDictionary[index] = ""

        skillLabel.MouseClick = function()
            itemSelectedLabel:SetText(index)
            currentlySelectedItem = skillLabel
            if SkillDictionary[index] ~= "" then
                skillSelected:SetText(SkillDictionary[index]:GetSkillInfo():GetName())
            else
                skillSelected:SetText("")
            end
        end
    end

    for i = 1, 12 do
        self.MakeSkillBox(i)
    end

    
    local SkillButton = Turbine.UI.Lotro.Button()
    SkillButton:SetParent(self)
    SkillButton:SetSize(100, 15)
    SkillButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SkillButton:SetMouseVisible(false)
    SkillButton:SetPosition(90, 104)
    SkillButton:SetText("Select skill")

    SkillButton.Click = function()
        menu:ShowMenu()
    end

    local NameBox = Turbine.UI.Lotro.TextBox()
    NameBox:SetParent(self)
    NameBox:SetSize(100, 30)
    NameBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    NameBox:SetPosition(400, 104)

    local BarButton = Turbine.UI.Lotro.Button()
    BarButton:SetParent(self)
    BarButton:SetSize(100, 30)
    BarButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    BarButton:SetMouseVisible(false)
    BarButton:SetPosition(530, 110)
    BarButton:SetText("Create Bar")

    BarButton.Click = function()
        local name = NameBox:GetText()
        if name ~= "" and LocalSkillBars[name] == nil then
            LocalSkillBars[name] = SkillDictionary
            CreateSkillBars(LocalSkillBars)
            removeLabel:SetVisible(true)
        else
            ChatOutput("No name or already existing name for bar!")
        end
    end

    self.MakeSkillBoxForShow = function(index, icon, parent)
        local skillLabel = Turbine.UI.Label()
        skillLabel:SetParent(parent)
        skillLabel:SetPosition(100 + 35 * index, 3)
        skillLabel:SetSize(32, 32)
        skillLabel:SetText(index)
        skillLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        if icon == nil then
            skillLabel:SetBackColor(GetRandomColour())
        else
            skillLabel:SetBackground(icon)
        end
        skillLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        skillLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        skillLabel:SetOutlineColor(OutlineColor)
    end

    self.CreateShowBar = function(value, listItem)
        for index, skillName in pairs(value) do
            local skill = SkillsByNames[skillName]
            if skill ~= nil then 
                self.MakeSkillBoxForShow(index, skill:GetSkillInfo():GetIconImageID(), listItem)
            else
                self.MakeSkillBoxForShow(index, nil, listItem)
            end
        end
    end

    
    local blablaLabel = Turbine.UI.Label()
    blablaLabel:SetSize(200, 40)
    blablaLabel:SetPosition(30, 170)
    blablaLabel:SetParent(self)
    blablaLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    blablaLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    blablaLabel:SetOutlineColor(OutlineColor)
    blablaLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    blablaLabel:SetText("Existing Action Bars:")

    if Tablelength(SkillBars) <= 0 then
        blablaLabel:SetVisible(false)
    end


    -- Show existing bars
    local listbox = Turbine.UI.ListBox();
    listbox:SetParent( self );
    --listbox:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
    listbox:SetPosition( 30, 200 );
    listbox:SetSize( 700, 240 );

    for key, value in pairs(SkillBars) do
        local listItem = Turbine.UI.Control();
        listItem:SetBackColor( GetRandomColour() );

        local nameLabel = Turbine.UI.Label()
        nameLabel:SetSize(100, 40)
        nameLabel:SetParent(listItem)
        nameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        nameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        nameLabel:SetOutlineColor(OutlineColor)
        nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        nameLabel:SetText(key)

        listItem:SetSize( 700, 40 );
        self.CreateShowBar(value, listItem)
        listbox:AddItem( listItem );

        local removeButton = Turbine.UI.Lotro.Button()
        removeButton:SetParent(listItem)
        removeButton:SetSize(100, 30)
        removeButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        removeButton:SetMouseVisible(false)
        removeButton:SetPosition(100 + 35 * 13, 10)
        removeButton:SetText("Remove Bar")

        removeButton.Click = function()
            ActiveSkillBars[key] = nil
            SkillBarsPositions[key] = nil
            CreateSkillBars(LocalSkillBars)
            listItem:SetVisible(false)
        end
    end
end


function RealSkill(description)
    for key, _ in pairs(ForbiddenSkills) do
        if string.find(description, key) then return true end
    end
    return false
end

ForbiddenSkills = {
    ["Allows the Warden to travel"] = true,
    ["goat"] = true,
    ["horse"] = true,
    ["Brings out"] = true,
    ["steed"] = true,
    ["Summons"] = true,
    ["This is a fleet-footed goat"] = true,
    ["A mighty Lasgalen elk"] = true,
    ["This skill suppresses all mount speed buffs"] = true,
    ["A favourite toy"] = true,
    ["A brightly coloured theme sets"] = true,
    ["Black as the night"] = true,
    ["Swallow this potion"] = true,
    ["This is probably the best snowball"] = true,
    ["An elite goat"] = true,
    ["Return quickly"] = true,
    ["Elk"] = true,
    ["Journey to the"] = true,
    ["Rescued from the cruelty of Lhaereth."] = true,
    ["return to"] = true,
    ["stag"] = true,
    ["pig"] = true,
    ["cow"] = true,
    ["sheep"] = true,
    ["deer"] = true,
    ["Toad"] = true,
    ["This black silk glove"] = true,
    ["A winged companion."] = true,
    ["Bill the Pony."] = true,
    ["he provides pleasant company"] = true,
    ["A token of thanks"] = true,
    ["Soldier"] = true,
    ["to ride alongside of you."] = true,
    ["A violent strike against the target that focuses on your offensive capability, dealing damage and increasing threat against the target."] = true,
    ["Skill of the Eorlingas becomes Halt the Charge."] = true,
    ["Return quickly"] = true,
    ["on the radar"] = true,
}

function CreateSkillBars(skillBar)
    for name, bar in pairs(skillBar) do
        ActiveSkillBars[name] =  SkillBar(bar, name)
    end
end

SkillBar = class(Turbine.UI.Window)
function SkillBar:Constructor(SkillList, name)
    local positions = SkillBarsPositions[name]
    local x = 0
    local y = 0
    if positions == nil then
        x = Settings.LOX
        y = Settings.LOY
    else
        x = positions[1]
        y = positions[2]
    end
    local width = 35 * 12
    local height = 32
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Window.Constructor(self);
    self:SetSize(width, height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(x,y);
    self:SetVisible(true)
    self:SetMouseVisible(false)
    --self:SetBackColor(GetRandomColour())

    count = 0
    for key, value in pairs(SkillList) do
        if value ~= "" then 
            local skillBox = SkillBox(count, self, value:GetCooldown())
            value.ResetTimeChanged = function(sender, args)
                skillBox:SkillUsed(value:GetResetTime() - Turbine.Engine.GetGameTime())
            end
            local currentCooldown = value:GetResetTime() - Turbine.Engine.GetGameTime()
            if currentCooldown > 0 then
                skillBox:SetCooldown(currentCooldown)
            end
        end
            count = count + 1
    end

    local moveBox = MoveBox(self, width, height, name)
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.GetSkillName = function()
        local nameList = {}
        for key, value in pairs(SkillList) do
            if value ~= "" then            
                nameList[key] = value:GetSkillInfo():GetName()
            else
                nameList[key] = ""
            end
        end
        return nameList
    end

    self.GetBarName = function()
        return(name)
    end

end

SkillBox = class(Turbine.UI.Window)
function SkillBox:Constructor(index, parent, cooldown)
    Turbine.UI.Window.Constructor(self)
    self:SetParent(parent)
    self:SetPosition(35 * index, 0)
    self:SetSize(32, 32)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.countdownLabel = Turbine.UI.Label()
    self.countdownLabel:SetSize(32, 32)
    self.countdownLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.countdownLabel:SetVisible(true)
    self.countdownLabel:SetParent(self)
    self.countdownLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.countdownLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.countdownLabel:SetOutlineColor(OutlineColor)
    self.countdownLabel:SetMultiline(false)
    self.countdownLabel:SetMouseVisible(false)

    self.CurrentCooldown = -1
    self.Countdown = cooldown
    
    local colorThreshold = cooldown / 8
    local decimalThreshold = 3

    local bigCooldown = cooldown >= 300
    local oldCooldown = cooldown

    self.ExecuteUpdate = function(sender, delta)
        self.CurrentCooldown = self.CurrentCooldown - delta
        if oldCooldown - self.CurrentCooldown > 0.05 then
            if self.CurrentCooldown < decimalThreshold and self.CurrentCooldown < 100 and not(bigCooldown) then
                self.countdownLabel:SetText(Round(self.CurrentCooldown, 1))
            elseif self.CurrentCooldown < 120 then
                self.countdownLabel:SetText(Round(self.CurrentCooldown, 0))
            else
                self.countdownLabel:SetText(Round(self.CurrentCooldown / 60, 0) .. "m")
            end
            oldCooldown = self.CurrentCooldown
        end

        if self.CurrentCooldown < 0 then
            --self:SetWantsUpdates(false)
            self:SetVisible(false)
            Updater:UnSubscribe(self)
        --elseif self.CurrentCooldown < colorThreshold and not(bigCooldown) then
        --    self.countdownLabel:SetForeColor(Turbine.UI.Color(1, 0, 0))
        end
    end

    
    self.SkillUsed = function(sender, countdown)
        self.SetCooldown(self, countdown)
        oldCooldown = countdown
    end

    self.SetCooldown = function(sender, value)
        self.CurrentCooldown = value
        self.countdownLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
        self:SetVisible(true)
        self.countdownLabel:SetText(value)
        --self:SetWantsUpdates(true)
        Updater:Subscribe(self)
    end


end

function CreateSkillBarFromSave()
    local skills = {}
    local tskills = Player:GetTrainedSkills()
    for i = 1, Player:GetTrainedSkills():GetCount(), 1 do
        local item = tskills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName() 
        local description = item:GetSkillInfo():GetDescription()

        if (not(RealSkill(description))and string.len(description) > 0 and item:GetSkillInfo():GetType() ~= 1) then
            skills[name] = item
        end
    end
    local CompleteSkillList = {}
    for key, value in pairs(SkillBars) do
        local SkillBarWithActualSkills = {}
        for index, skillName in pairs(value) do
            local skill = skills[skillName]
            if skill ~= nil then 
                SkillBarWithActualSkills[index] = skill
            else
                SkillBarWithActualSkills[index] = ""
            end
        end
        CompleteSkillList[key] = SkillBarWithActualSkills
    end

    CreateSkillBars(CompleteSkillList)

    --table.insert( ActiveSkillBars, SkillBar(SkillBars, name))

end