SkillTimerSettings = class(Turbine.UI.Control)
function SkillTimerSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,75);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    
    --E.PlayerEffects ->
    --E.AllPlayerEffects -> Generic group effects

    local AllButton = Turbine.UI.Lotro.Button()
    AllButton:SetParent(self)
    AllButton:SetSize(200, 15)
    AllButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    AllButton:SetMouseVisible(true)
    AllButton:SetPosition(175, 50)
    AllButton:SetText("All player effects")

    local SelfButton = Turbine.UI.Lotro.Button()
    SelfButton:SetParent(self)
    SelfButton:SetSize(200, 15)
    SelfButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SelfButton:SetMouseVisible(true)
    SelfButton:SetPosition(450, 50)
    SelfButton:SetText("Specific player effects")

    local AllPlayerEffectWindow = Turbine.UI.Control()
    AllPlayerEffectWindow:SetSize(width, height - 75)
    AllPlayerEffectWindow:SetPosition(0, 75)
    AllPlayerEffectWindow:SetParent(self)

    local SpecificPlayerEffectWindow = Turbine.UI.Control()
    SpecificPlayerEffectWindow:SetSize(width, height - 75)
    SpecificPlayerEffectWindow:SetPosition(0, 75)
    SpecificPlayerEffectWindow:SetParent(self)
    SpecificPlayerEffectWindow:SetVisible(false)

    self.MakeAllPlayerEffects = function()
        --AllPlayerEffectWindow:SetBackColor(GoldColor)
    
        local InfoLabel = Turbine.UI.Label()
        InfoLabel:SetParent(AllPlayerEffectWindow)
        InfoLabel:SetSize(200, 100)
        InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        InfoLabel:SetMouseVisible(false)
        InfoLabel:SetPosition(300, 300)
        InfoLabel:SetVisible(false)
        InfoLabel:SetText("Reload the plugin to see the effects of your actions. Sometimes it requires time so you need to reload an additional time in order for the data to be loaded correctly!")
    
        local DescriptionLabel = Turbine.UI.Label()
        DescriptionLabel:SetParent(AllPlayerEffectWindow)
        DescriptionLabel:SetSize(200, 15)
        DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DescriptionLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DescriptionLabel:SetPosition(30, 35)
        DescriptionLabel:SetText("Currently shown effects: ")
    
        local ItemSelectedInfoLabel = Turbine.UI.Label()
        ItemSelectedInfoLabel:SetParent(AllPlayerEffectWindow)
        ItemSelectedInfoLabel:SetSize(200, 15)
        ItemSelectedInfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemSelectedInfoLabel:SetMouseVisible(false)
        ItemSelectedInfoLabel:SetPosition(300, 50)
        ItemSelectedInfoLabel:SetText("Item selected:")
    
        local ItemSelectedLabel = Turbine.UI.Label()
        ItemSelectedLabel:SetParent(AllPlayerEffectWindow)
        ItemSelectedLabel:SetSize(200, 15)
        ItemSelectedLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemSelectedLabel:SetMouseVisible(false)
        --ItemSelectedLabel:SetMultiline(false)
        ItemSelectedLabel:SetPosition(300, 70)
    
        local RemoveButton = Turbine.UI.Lotro.Button()
        RemoveButton:SetParent(AllPlayerEffectWindow)
        RemoveButton:SetSize(100, 15)
        RemoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        RemoveButton:SetMouseVisible(false)
        RemoveButton:SetPosition(300, 90)
        RemoveButton:SetText("Remove Item")
    
        RemoveButton.Click = function()
            --TargetEffects[ItemSelectedLabel:GetText()] = nil
            if AddedCharSkillTimersAll[ItemSelectedLabel:GetText()] then 
                AddedCharSkillTimersAll[ItemSelectedLabel:GetText()] = nil
            else
                RemovedBasicSkillTimersAll[ItemSelectedLabel:GetText()] = true--E.PlayerEffects[ItemSelectedLabel:GetText()]
            end
            ChatOutput("Removed effect: " .. ItemSelectedLabel:GetText())
            InfoLabel:SetVisible(true)
        end
    
        local AddButton = Turbine.UI.Lotro.Button()
        AddButton:SetParent(AllPlayerEffectWindow)
        AddButton:SetSize(100, 15)
        AddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        AddButton:SetMouseVisible(false)
        AddButton:SetPosition(400, 90)
        AddButton:SetText("Add Item")
    
        AddButton.Click = function()
            --E.AllPlayerEffects[ItemSelectedLabel:GetText()] = RemovedBasicSkillTimersAll[ItemSelectedLabel:GetText()]
            RemovedBasicSkillTimersAll[ItemSelectedLabel:GetText()] = nil
            ChatOutput("ReAdded effect: " .. ItemSelectedLabel:GetText())
            InfoLabel:SetVisible(true)
        end
    
        local container = Turbine.UI.ListBox()
        container:SetParent(AllPlayerEffectWindow)
        container:SetSize(200, height - 100)
        container:SetPosition(30, 50)
        --container:SetBackColor(GoldColor)
        container:SetVisible(true)
        container:SetWantsKeyEvents(true)
        container:SetMouseVisible(true)
    
        local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
        containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
        containerScrollbar:SetParent( AllPlayerEffectWindow );
        containerScrollbar:SetPosition( 230 - 10, 50 );
        containerScrollbar:SetSize( 10, height - 100 );
        container:SetVerticalScrollBar( containerScrollbar );
    
        local sortedAllPlayerSkills = {}
        for key, value in pairs(E.AllPlayerEffects) do table.insert( sortedAllPlayerSkills,key ) end
        table.sort( sortedAllPlayerSkills )
    
        for key, value in pairs(sortedAllPlayerSkills) do
            AddListItem(value, container, ItemSelectedLabel)
        end
    
        -- [1] duration [2] name [3] unique [4] activity timer [5] show activity
    
        -- Name
        local DescriptionLabel = Turbine.UI.Label()
        DescriptionLabel:SetParent(AllPlayerEffectWindow)
        DescriptionLabel:SetSize(200, 15)
        DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DescriptionLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DescriptionLabel:SetPosition(170, 135)
        DescriptionLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
        DescriptionLabel:SetText("Name:")
    
        local ItemTextBox = Turbine.UI.Lotro.TextBox()
        ItemTextBox:SetParent(AllPlayerEffectWindow)
        ItemTextBox:SetSize(200, 30)
        ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemTextBox:SetMouseVisible(false)
        ItemTextBox:SetPosition(300, 130)
    
        --Duration
        local DescriptionLabel2 = Turbine.UI.Label()
        DescriptionLabel2:SetParent(AllPlayerEffectWindow)
        DescriptionLabel2:SetSize(200, 15)
        DescriptionLabel2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DescriptionLabel2:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DescriptionLabel2:SetPosition(170, 165)
        DescriptionLabel2:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
        DescriptionLabel2:SetText("CD:")
    
        local ItemTextBox2 = Turbine.UI.Lotro.TextBox()
        ItemTextBox2:SetParent(AllPlayerEffectWindow)
        ItemTextBox2:SetSize(100, 30)
        ItemTextBox2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemTextBox2:SetMouseVisible(false)
        ItemTextBox2:SetPosition(350, 160)
    
        --Unique
        local cBox = Turbine.UI.Lotro.CheckBox();
        cBox:SetParent(AllPlayerEffectWindow)
        cBox:SetPosition(370, 190);
        cBox:SetSize(300,40);
        cBox:SetChecked(Settings.TEffects)
        cBox:SetText("Unique");
        cBox:SetVisible(true);
    
    
        --Activity Timer
        local cBox2 = Turbine.UI.Lotro.CheckBox();
        cBox2:SetParent(AllPlayerEffectWindow)
        cBox2:SetPosition(370, 210);
        cBox2:SetSize(300,40);
        cBox2:SetChecked(Settings.TEffects)
        cBox2:SetText("Activity timer");
        cBox2:SetVisible(true);
    
        local TextAddButton = Turbine.UI.Lotro.Button()
        TextAddButton:SetParent(AllPlayerEffectWindow)
        TextAddButton:SetSize(200, 15)
        TextAddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        TextAddButton:SetMouseVisible(false)
        TextAddButton:SetPosition(300, 250)
        TextAddButton:SetText("Add Effect")
    
        TextAddButton.Click = function()
            if ItemTextBox:GetText() ~= nil and ItemTextBox2:GetText() ~= nil then
                local checkItem = nil
                if cBox2:IsChecked() then
                    checkItem = true
                end
                local item = {tonumber(ItemTextBox2:GetText()), ItemTextBox:GetText(), cBox:IsChecked(), checkItem, checkItem}
                E.AllPlayerEffects[ItemTextBox:GetText()] = item
                AddedCharSkillTimersAll[ItemTextBox:GetText()] = item
                ChatOutput("Added effect: " .. ItemTextBox:GetText())
                InfoLabel:SetVisible(true)
            end
        end
    
        local RemovedDescriptionLabel = Turbine.UI.Label()
        RemovedDescriptionLabel:SetParent(AllPlayerEffectWindow)
        RemovedDescriptionLabel:SetSize(200, 15)
        RemovedDescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        RemovedDescriptionLabel:SetMouseVisible(false)
        RemovedDescriptionLabel:SetPosition(530, 35)
        RemovedDescriptionLabel:SetText("Deleted default effects: ")
    
        local removedContainer = Turbine.UI.ListBox()
        removedContainer:SetParent(AllPlayerEffectWindow)
        removedContainer:SetSize(200, height - 100)
        removedContainer:SetPosition(530, 50)
        --removedContainer:SetBackColor(GoldColor)
        removedContainer:SetVisible(true)
        removedContainer:SetWantsKeyEvents(true)
        removedContainer:SetMouseVisible(true)
    
        local removedContainerScrollbar = Turbine.UI.Lotro.ScrollBar();
        removedContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
        removedContainerScrollbar:SetParent( self );
        removedContainerScrollbar:SetPosition( 730 - 10, 50 );
        removedContainerScrollbar:SetSize( 10, height - 100 );
        removedContainer:SetVerticalScrollBar( removedContainerScrollbar );
    
        local RemovedSortedEffects = {}
        for key, value in pairs(RemovedBasicSkillTimersAll) do table.insert( RemovedSortedEffects,key ) end
        table.sort( RemovedSortedEffects )
    
        for key, value in pairs(RemovedSortedEffects) do
            AddListItem(value, removedContainer, ItemSelectedLabel)
        end
    end

    self.MakeSpecificPlayerEffects = function()
        --AllPlayerEffectWindow:SetBackColor(GoldColor)
    
        local InfoLabel = Turbine.UI.Label()
        InfoLabel:SetParent(SpecificPlayerEffectWindow)
        InfoLabel:SetSize(200, 100)
        InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        InfoLabel:SetMouseVisible(false)
        InfoLabel:SetPosition(300, 300)
        InfoLabel:SetVisible(false)
        InfoLabel:SetText("Reload the plugin to see the effects of your actions. Sometimes it requires time so you need to reload an additional time in order for the data to be loaded correctly!")
    
        local DescriptionLabel = Turbine.UI.Label()
        DescriptionLabel:SetParent(SpecificPlayerEffectWindow)
        DescriptionLabel:SetSize(200, 15)
        DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DescriptionLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DescriptionLabel:SetPosition(30, 35)
        DescriptionLabel:SetText("Currently shown effects: ")
    
        local ItemSelectedInfoLabel = Turbine.UI.Label()
        ItemSelectedInfoLabel:SetParent(SpecificPlayerEffectWindow)
        ItemSelectedInfoLabel:SetSize(200, 15)
        ItemSelectedInfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemSelectedInfoLabel:SetMouseVisible(false)
        ItemSelectedInfoLabel:SetPosition(300, 50)
        ItemSelectedInfoLabel:SetText("Item selected:")
    
        local ItemSelectedLabel = Turbine.UI.Label()
        ItemSelectedLabel:SetParent(SpecificPlayerEffectWindow)
        ItemSelectedLabel:SetSize(200, 15)
        ItemSelectedLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemSelectedLabel:SetMouseVisible(false)
        --ItemSelectedLabel:SetMultiline(false)
        ItemSelectedLabel:SetPosition(300, 70)
    
        local RemoveButton = Turbine.UI.Lotro.Button()
        RemoveButton:SetParent(SpecificPlayerEffectWindow)
        RemoveButton:SetSize(100, 15)
        RemoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        RemoveButton:SetMouseVisible(false)
        RemoveButton:SetPosition(300, 90)
        RemoveButton:SetText("Remove Item")
    
        RemoveButton.Click = function()
            --TargetEffects[ItemSelectedLabel:GetText()] = nil
            if AddedCharSkillTimersSpecific[ItemSelectedLabel:GetText()] then 
                AddedCharSkillTimersSpecific[ItemSelectedLabel:GetText()] = nil
            else
                RemovedBasicSkillTimersSpecific[ItemSelectedLabel:GetText()] = true--E.PlayerEffects[ItemSelectedLabel:GetText()]
            end
            ChatOutput("Removed effect: " .. ItemSelectedLabel:GetText())
            InfoLabel:SetVisible(true)
        end
    
        local AddButton = Turbine.UI.Lotro.Button()
        AddButton:SetParent(SpecificPlayerEffectWindow)
        AddButton:SetSize(100, 15)
        AddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        AddButton:SetMouseVisible(false)
        AddButton:SetPosition(400, 90)
        AddButton:SetText("Add Item")
    
        AddButton.Click = function()
            --E.AllPlayerEffects[ItemSelectedLabel:GetText()] = RemovedBasicSkillTimersAll[ItemSelectedLabel:GetText()]
            RemovedBasicSkillTimersAll[ItemSelectedLabel:GetText()] = nil
            ChatOutput("ReAdded effect: " .. ItemSelectedLabel:GetText())
            InfoLabel:SetVisible(true)
        end
    
        local container = Turbine.UI.ListBox()
        container:SetParent(SpecificPlayerEffectWindow)
        container:SetSize(200, height - 100)
        container:SetPosition(30, 50)
        --container:SetBackColor(GoldColor)
        container:SetVisible(true)
        container:SetWantsKeyEvents(true)
        container:SetMouseVisible(true)
    
        local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
        containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
        containerScrollbar:SetParent( SpecificPlayerEffectWindow );
        containerScrollbar:SetPosition( 230 - 10, 50 );
        containerScrollbar:SetSize( 10, height - 100 );
        container:SetVerticalScrollBar( containerScrollbar );
    
        local sortedAllPlayerSkills = {}
        for key, value in pairs(E.PlayerEffects) do 
            for key2, value2 in pairs(value) do
                table.insert( sortedAllPlayerSkills,key2 ) 
            end
        end
        table.sort( sortedAllPlayerSkills )
    
        for key, value in pairs(sortedAllPlayerSkills) do
            AddListItem(value, container, ItemSelectedLabel)
        end
    
        -- [1] duration [2] name [3] unique [4] activity timer [5] show activity
    
        -- Name
        local DescriptionLabel = Turbine.UI.Label()
        DescriptionLabel:SetParent(SpecificPlayerEffectWindow)
        DescriptionLabel:SetSize(200, 15)
        DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DescriptionLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DescriptionLabel:SetPosition(170, 135)
        DescriptionLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
        DescriptionLabel:SetText("Name:")
    
        local ItemTextBox = Turbine.UI.Lotro.TextBox()
        ItemTextBox:SetParent(SpecificPlayerEffectWindow)
        ItemTextBox:SetSize(200, 30)
        ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemTextBox:SetMouseVisible(false)
        ItemTextBox:SetPosition(300, 130)
    
        --Duration
        local DescriptionLabel2 = Turbine.UI.Label()
        DescriptionLabel2:SetParent(SpecificPlayerEffectWindow)
        DescriptionLabel2:SetSize(200, 15)
        DescriptionLabel2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DescriptionLabel2:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DescriptionLabel2:SetPosition(170, 165)
        DescriptionLabel2:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
        DescriptionLabel2:SetText("CD:")
    
        local ItemTextBox2 = Turbine.UI.Lotro.TextBox()
        ItemTextBox2:SetParent(SpecificPlayerEffectWindow)
        ItemTextBox2:SetSize(100, 30)
        ItemTextBox2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemTextBox2:SetMouseVisible(false)
        ItemTextBox2:SetPosition(350, 160)
    
        --Unique
        local cBox = Turbine.UI.Lotro.CheckBox();
        cBox:SetParent(SpecificPlayerEffectWindow)
        cBox:SetPosition(370, 190);
        cBox:SetSize(300,40);
        cBox:SetChecked(Settings.TEffects)
        cBox:SetText("Unique");
        cBox:SetVisible(true);
    
    
        --Activity Timer
        local cBox2 = Turbine.UI.Lotro.CheckBox();
        cBox2:SetParent(SpecificPlayerEffectWindow)
        cBox2:SetPosition(370, 210);
        cBox2:SetSize(300,40);
        cBox2:SetChecked(Settings.TEffects)
        cBox2:SetText("Activity timer");
        cBox2:SetVisible(true);
    
        local TextAddButton = Turbine.UI.Lotro.Button()
        TextAddButton:SetParent(SpecificPlayerEffectWindow)
        TextAddButton:SetSize(200, 15)
        TextAddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        TextAddButton:SetMouseVisible(false)
        TextAddButton:SetPosition(300, 275)
        TextAddButton:SetText("Add Effect")

        -- Name
        local DescriptionLabel3 = Turbine.UI.Label()
        DescriptionLabel3:SetParent(SpecificPlayerEffectWindow)
        DescriptionLabel3:SetSize(200, 15)
        DescriptionLabel3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DescriptionLabel3:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DescriptionLabel3:SetPosition(170, 245)
        DescriptionLabel3:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
        DescriptionLabel3:SetText("Class:")

        local ClassButton = Turbine.UI.Lotro.Button()
        ClassButton:SetParent(SpecificPlayerEffectWindow)
        ClassButton:SetSize(200, 15)
        ClassButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ClassButton:SetMouseVisible(true)
        ClassButton:SetPosition(300, 245)
        ClassButton:SetText("Class")

        local menu = Turbine.UI.ContextMenu()
        local menuItems = menu:GetItems()

        local sortedKeys2 = {}
        for key, value in pairs(ClassnameToObject) do table.insert( sortedKeys2, key ) end
        table.sort( sortedKeys2 )
        
        for key, name in pairs(sortedKeys2) do
            local menuItem = Turbine.UI.MenuItem( name )
    
            menuItem.Click = function()
                ClassButton:SetText(name)
            end
            
            menuItems:Add(menuItem)
        end

        ClassButton.Click = function()
            menu:ShowMenu()
        end
    
        TextAddButton.Click = function()
            if ItemTextBox:GetText() ~= nil and ItemTextBox2:GetText() ~= nil and ClassButton:GetText() ~= "Class" then
                local checkItem = nil
                if cBox2:IsChecked() then
                    checkItem = true
                end
                local item = {tonumber(ItemTextBox2:GetText()), ItemTextBox:GetText(), cBox:IsChecked(), checkItem, checkItem, nil}
                E.PlayerEffects[ClassnameToObject[ClassButton:GetText()]][ItemTextBox:GetText()] = item
                item[6] = ClassButton:GetText()
                AddedCharSkillTimersSpecific[ItemTextBox:GetText()] = item 
                ChatOutput("Added effect: " .. ItemTextBox:GetText())
                InfoLabel:SetVisible(true)
            end
        end
    
        local RemovedDescriptionLabel = Turbine.UI.Label()
        RemovedDescriptionLabel:SetParent(SpecificPlayerEffectWindow)
        RemovedDescriptionLabel:SetSize(200, 15)
        RemovedDescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        RemovedDescriptionLabel:SetMouseVisible(false)
        RemovedDescriptionLabel:SetPosition(530, 35)
        RemovedDescriptionLabel:SetText("Deleted default effects: ")
    
        local removedContainer = Turbine.UI.ListBox()
        removedContainer:SetParent(SpecificPlayerEffectWindow)
        removedContainer:SetSize(200, height - 100)
        removedContainer:SetPosition(530, 50)
        --removedContainer:SetBackColor(GoldColor)
        removedContainer:SetVisible(true)
        removedContainer:SetWantsKeyEvents(true)
        removedContainer:SetMouseVisible(true)
    
        local removedContainerScrollbar = Turbine.UI.Lotro.ScrollBar();
        removedContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
        removedContainerScrollbar:SetParent( self );
        removedContainerScrollbar:SetPosition( 730 - 10, 50 );
        removedContainerScrollbar:SetSize( 10, height - 100 );
        removedContainer:SetVerticalScrollBar( removedContainerScrollbar );
    
        local RemovedSortedEffects = {}
        for key, value in pairs(RemovedBasicSkillTimersAll) do table.insert( RemovedSortedEffects,key ) end
        table.sort( RemovedSortedEffects )
    
        for key, value in pairs(RemovedSortedEffects) do
            AddListItem(value, removedContainer, ItemSelectedLabel)
        end
    end

    self.MakeAllPlayerEffects()
    self.MakeSpecificPlayerEffects()

    AllButton.Click = function()
        AllPlayerEffectWindow:SetVisible(true)
        SpecificPlayerEffectWindow:SetVisible(false)
    end

    SelfButton.Click = function()
        AllPlayerEffectWindow:SetVisible(false)
        SpecificPlayerEffectWindow:SetVisible(true)
    end


    
end

