SkillTimers = class(Turbine.UI.Window)
function SkillTimers:Constructor(timerType)
    local width = 0
    local height = 0
    local x = 0
    local y = 0
    if timerType == 0 then 
        width = Settings.SPWidth2
        height = Settings.SPHeight2
        x = Settings.SPX2
        y = Settings.SPY2
    else
        width = Settings.SPAWidth
        height = Settings.SPAHeight
        x = Settings.SPAX
        y = Settings.SPAY
    end
    local cooldownTimer = 0
    local oldGameTime = Turbine.Engine.GetGameTime()
    local Timers = {}
    local ID = 0
    local clearTimer = 0
    local TimerType= timerType
    local resort = false

    Turbine.UI.Window.Constructor(self);
    self:SetSize(width,height);
    self:SetPosition(x,y);
    self:SetZOrder(1);

    self:SetWantsKeyEvents(true)
    self:SetMouseVisible(false)
    self:SetVisible(true)
    --self:SetWantsUpdates(true)

    self.messageBox = Turbine.UI.Label()
    self.messageBox:SetParent(self)
    self.messageBox:SetSize(width,height)
    self.messageBox:SetPosition(0,0)
    self.messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox:SetFont(Settings.SPFont)
    self.messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox:SetMouseVisible(false)
    self.messageBox:SetVisible(false)
  
    local moveBox = MoveBox(self, width, height, "Skill Timers")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.ExecuteUpdate = function(sender, delta)   
        --We had an update
        for key, value in pairs(Timers) do 
            value[2] = value[2] - delta
            value[1]:UpdateText(delta)
            if value[2] < 0 then 
                --PrintTable(Timers)
                --ChatOutput("Delete ID: " .. key)
                value[1]:Destroy()
                Timers[key] = nil
                --PrintTable(Timers)
                resort = true
            end
            --value[1]:SetText(value[3].." "..value[2])
        end

        if resort then 
            if tablelength(Timers) == 0 then 
                Updater:UnSubscribe(self) 
                Timers = nil
                collectgarbage()
                Timers = {}
                return
            end
            self.ResortList() 
        end
    end

    -- Add a timer
    self.NewTimer = function(sender, duration, effectName, message, unique, activityTimer, showActivity, icon, name)
        local count = tablelength(Timers)
        local timerMessage = ""
        if unique then
            if activityTimer == nil then ChatOutput("Nill timer for: " .. effectName) end
            for key, value in pairs(Timers) do
                --ChatOutput(value[4] .. " " .. effectName)
                if value[4] == effectName and (TimerType == 1 or duration - activityTimer < value[1]:GetRemainingTime()) then 
                    --ChatOutput("Return")
                    return
                 end
            end
        end

        if E.BetterEffectIcons[effectName] ~= nil then
            icon = E.BetterEffectIcons[effectName]
        end

        if showActivity ~= nil and TimerType ==  1 then
            if not(E.GroupEffectsActive[effectName]) then
                timerMessage = name
            else
                timerMessage = message
            end
            Timers[#Timers + 1] = {Counter(self, width, Settings.SPTimerHeight2, count, activityTimer, timerMessage, Settings.SPNewFont, TimerColourActive1, TimerColourActive2, TimerColourActive3, TimerColourActive4, TimerColourActive5, icon), activityTimer, timerMessage, effectName, unique}
            --count = count + 1
        end
             --Timers[ID] =  {Counter(self, width, height, count, duration, message), duration, message}
        if TimerType == 0 then
            if not(E.GroupEffectsCooldown[effectName]) then
                timerMessage = name
            else
                timerMessage = message
            end
            Timers[#Timers + 1] = {Counter(self, width, Settings.SPTimerHeight2, count, duration, timerMessage, Settings.SPNewFont, TimerColourNormal1, TimerColourNormal2, TimerColourNormal3, TimerColourNormal4, TimerColourNormal5, icon), duration, timerMessage, effectName, unique}
        end

        --ID = ID + 1
        resort = true

        Updater:Subscribe(self)
        --PrintTable(Timers)
    end

    self.Clear = function()
        for key, value in pairs(Timers) do 
            value[1]:Destroy()
            Timers[key] = nil
        end

        if Tablelength(Timers) > 0 then
            self.Clear()
        end

        Timers = nil
        collectgarbage()
        Timers = {}
    end

    self.ResortList = function()
        if Tablelength(Timers) > 1 then  
            table.sort(Timers, Compare)
        end
        local counter = 0
        for key, value in pairs(Timers) do
            value[1]:SetPosition(0, counter * Settings.SPTimerHeight2) 
            counter = counter + 1
        end

        resort = false
    end
end




