SkillWindow = class(Turbine.UI.Window)

function SkillWindow:Constructor()
    local width = Settings.SWWidth
    local height = 100
    local x = Settings.SWX
    local y = Settings.SWY
    local cooldownTimer = 0
    local combat = nil
    local minutes = 0
    local seconds = 0
    local ResetTimes = {}
    local EarliestReset = nil
    local Labels = {}

    Turbine.UI.Window.Constructor(self);
    self:SetSize(width,height);
    self:SetPosition(x,y);
    self:SetZOrder(1);

    --self:SetWantsKeyEvents(true)
    self:SetMouseVisible(false)
    self:SetVisible(Settings.SWVisible)
    --self:SetWantsUpdates(false)

    self.ExecuteUpdate = function()
        if Turbine.Engine.GetGameTime() >= EarliestReset then
            for key, value in pairs(ResetTimes) do
                if value == EarliestReset then
                    ResetTimes[key] = nil
                    Labels[key]:SwapState(false)
                    Sounds:PlaySoundEffect(SoundEffects["Ping"])
                    EarliestReset = nil
                    for item, item2 in pairs(ResetTimes) do
                        if EarliestReset == nil or EarliestReset > item2 then
                            EarliestReset = item2
                        end
                    end

                    if EarliestReset == nil then
                        --self:SetWantsUpdates(false)
                        Updater:UnSubscribe(self)
                    end
                end
            end
        end
    end


    local tskills = Player:GetTrainedSkills()
    local counter = 0

    for i = 1, Player:GetTrainedSkills():GetCount(), 1 do
        local item = tskills:GetItem(i)--:GetSkillInfo()

        --ChatOutput(item:GetSkillInfo():GetName() .. " " .. item:GetSkillInfo():GetIconImageID())

        if logWindow ~= nil and item:GetResetTime() ~= nil then
            item.ResetTimeChanged = function(sender, args)
                logWindow:Message(item:GetSkillInfo():GetName(), false)
            end
        end
        
        if SkillAlerts.PlayerEffects[Player:GetClass()][item:GetSkillInfo():GetName()] then
            local itemInfo = item:GetSkillInfo()
            local usable = false
            if item:GetResetTime() < 0 then
                usable = true
            elseif EarliestReset == nil or item:GetResetTime() < EarliestReset then
               -- ChatOutput("XD")
                EarliestReset = item:GetResetTime()
                ResetTimes[itemInfo:GetName()] = item:GetResetTime()
                --self:SetWantsUpdates(true)
                Updater:Subscribe(self)
            end
            Labels[itemInfo:GetName()] = SkillLabel(itemInfo:GetIconImageID(), itemInfo:GetName(), self, usable, counter, item:GetCooldown())
            Labels[itemInfo:GetName()]:SetVisible(usable)
            item.ResetTimeChanged = function(sender, args)
                ResetTimes[itemInfo:GetName()] = item:GetResetTime()
                Labels[itemInfo:GetName()]:SwapState(true)
                Labels[itemInfo:GetName()]:SkillUsed()
                if EarliestReset == nil or EarliestReset > item:GetResetTime() then
                    EarliestReset = item:GetResetTime()
                end
                --self:SetWantsUpdates(true)
                Updater:Subscribe(self)
            end
            --ChatOutput(EarliestReset)
            counter = counter + 1
        end
    end

    height = 32 * tablelength(Labels)
    self:SetSize(width, height)

    local moveBox = MoveBox(self, width, height, "Skill Alerts")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end
end

SkillLabel = class(Turbine.UI.Control)
function SkillLabel:Constructor(image, message, parent, visible, index, cooldown)
    Turbine.UI.Control.Constructor(self);
    self:SetParent(parent)
    self:SetVisible(true)
    self:SetSize(100, 32)
    self:SetPosition(0, 32 * index)
    --self:SetBackColor(Turbine.UI.Color(0,0,0))
    self:SetMouseVisible(false)
    
    self.Countdown = cooldown
    self.CurrentCooldown = -2

    local colorThreshold = cooldown / 8
    local decimalThreshold = 3

    local bigCooldown = cooldown >= 300
    local oldCooldown = cooldown

    self.opacityWindow = Turbine.UI.Window()
    self.opacityWindow:SetParent(self)
    self.opacityWindow:SetSize(32, 32)
    self.opacityWindow:SetPosition(0,0)
    self.opacityWindow:SetMouseVisible(false)
    self.opacityWindow:SetVisible(true)
    --self.opacityWindow:SetBackColor(OutlineColor)
    --self.opacityWindow:SetOpacity(0.5)

    
    self.opacityWindow2 = Turbine.UI.Window()
    self.opacityWindow2:SetParent(self)
    self.opacityWindow2:SetSize(32, 32)
    self.opacityWindow2:SetPosition(0,0)
    self.opacityWindow2:SetMouseVisible(false)
    self.opacityWindow2:SetVisible(true)
    --self.opacityWindow2:SetBackColor(OutlineColor)
    --self.opacityWindow2:SetOpacity1)

    self.icon = Turbine.UI.Label()
    self.icon:SetParent(self.opacityWindow)
    self.icon:SetSize(32, 32)
    self.icon:SetPosition(0,0)
    self.icon:SetBackground(image)
    self.icon:SetMouseVisible(false)
    --self.icon:SetStretchMode(1)

    self.countdownLabel = Turbine.UI.Label()
    self.countdownLabel:SetParent(self.opacityWindow2)
    self.countdownLabel:SetSize(32, 32)
    self.countdownLabel:SetPosition(0, 0)
    self.countdownLabel:SetMouseVisible(false)
    self.countdownLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.countdownLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.countdownLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)

    self.label = Turbine.UI.Label()
    self.label:SetParent(self)
    self.label:SetSize(100 - 32, 32)
    self.label:SetPosition(32,0)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiqua18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetMouseVisible(false)
    self.label:SetVisible(false)
    self.label:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.label:SetForeColor(Turbine.UI.Color(0, 1, 0))
    --self.label:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.label:SetText("READY")

    self.SwapState = function(sender, state)
        --self:SetVisible(not(state))
        if state then 
            self.opacityWindow:SetOpacity(0.5)
            self.opacityWindow:SetBackColor(OutlineColor)
        else 
            self.opacityWindow:SetOpacity(1)
            self.opacityWindow:SetBackColor()
        end
        self.label:SetVisible(not(state))
        
    end

    self.SkillUsed = function()
        self.CurrentCooldown = self.Countdown
        self.countdownLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
        self.countdownLabel:SetVisible(true)
        self.countdownLabel:SetText(self.Countdown)
        --self:SetWantsUpdates(true)
        Updater:Subscribe(self)
    end

    self.ExecuteUpdate = function(sender, delta)
        self.CurrentCooldown = self.CurrentCooldown - delta

        if oldCooldown - self.CurrentCooldown > 0.05 then
            if self.CurrentCooldown < decimalThreshold and self.CurrentCooldown < 100 and not(bigCooldown) then
                self.countdownLabel:SetText(Round(self.CurrentCooldown, 1))
            elseif self.CurrentCooldown < 120 then
                self.countdownLabel:SetText(Round(self.CurrentCooldown, 0))
            else
                self.countdownLabel:SetText(Round(self.CurrentCooldown / 60, 0) .. "m")
            end
            oldCooldown = self.CurrentCooldown
        end

        if self.CurrentCooldown < 0 then
            --self:SetWantsUpdates(false)
            self:SetVisible(false)
            Updater:UnSubscribe(self)
        --elseif self.CurrentCooldown < colorThreshold and not(bigCooldown) then
        --    self.countdownLabel:SetForeColor(Turbine.UI.Color(1, 0, 0))
        end
    end
end