CharStats = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeCharStats")

if CharStats == nil then
    CharStats = {}
    CharStats["Time"] = 0
    CharStats["KB"] = {}
    CharStats["Reload"] = 0
    CharStats["Death"] = 0
    CharStats["KilledBy"] = {}
    CharStats["DamageTaken"] = 0
    CharStats["DamageDealt"] = 0
    CharStats["Healing"] = 0
end

AccountStats = Turbine.PluginData.Load(Turbine.DataScope.Account, "PrimeAccountStats")

if AccountStats == nil then
    AccountStats = {}
    AccountStats["Time"] = 0
    AccountStats["KB"] = {}
    AccountStats["Reload"] = 0
    AccountStats["Death"] = 0
    AccountStats["KilledBy"] = {}
    AccountStats["DamageTaken"] = 0
    AccountStats["DamageDealt"] = 0
    AccountStats["Healing"] = 0
end

local accountDamageDealt = 0
local accountDamageTaken = 0
local accountHealing = 0
local characterDamageDealt = 0
local characterDamageTaken = 0
local characterHealing = 0

local PluginStartTime = Turbine.Engine.GetGameTime()

function AddKB(kb)
    if kb == nil then return end
    if CharStats["KB"][kb] == nil then
        CharStats["KB"][kb] = 1
    else
        CharStats["KB"][kb] = CharStats["KB"][kb] + 1 
    end

    if AccountStats["KB"][kb] == nil then
        AccountStats["KB"][kb] = 1
    else
        AccountStats["KB"][kb] = AccountStats["KB"][kb] + 1 
    end
end

function AddDamageTaken(dam)
    characterDamageTaken = characterDamageTaken + dam
    accountDamageTaken = accountDamageTaken + dam
end

function AddDamageDealt(dam)
    characterDamageDealt = characterDamageDealt + dam
    accountDamageDealt = accountDamageDealt + dam
end

function AddHealing(heal)
    characterHealing = characterHealing + heal
    accountHealing = accountHealing + heal
end

function AddReload()
    CharStats["Reload"] = CharStats["Reload"] + 1
    AccountStats["Reload"] = AccountStats["Reload"] + 1
end

function AddDeath(kb)
    if CharStats["KilledBy"] == nil then  CharStats["KilledBy"] = {} end
    if AccountStats["KilledBy"] == nil then  AccountStats["KilledBy"] = {} end

    CharStats["Death"] = CharStats["Death"] + 1
    AccountStats["Death"] = AccountStats["Death"] + 1

    if kb == nil then return end

    if CharStats["KilledBy"][kb] == nil then
        CharStats["KilledBy"][kb] = 1
    else
        CharStats["KilledBy"][kb] = CharStats["KilledBy"][kb] + 1 
    end

    if AccountStats["KilledBy"][kb] == nil then
        AccountStats["KilledBy"][kb] = 1
    else
        AccountStats["KilledBy"][kb] = AccountStats["KilledBy"][kb] + 1 
    end
end

function SaveStats()
    local pluginUptime = Turbine.Engine.GetGameTime() - PluginStartTime

    -- Handle char stats
    CharStats["Time"] = CharStats["Time"] + pluginUptime
    CharStats["DamageTaken"] = CharStats["DamageTaken"] + characterDamageTaken
    CharStats["DamageDealt"] = CharStats["DamageDealt"] + characterDamageDealt
    CharStats["Healing"] = CharStats["Healing"] + characterHealing
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeCharStats", CharStats)

    -- Handle account stats
    AccountStats["Time"] = AccountStats["Time"] + pluginUptime
    AccountStats["DamageTaken"] = AccountStats["DamageTaken"] + accountDamageTaken
    AccountStats["DamageDealt"] = AccountStats["DamageDealt"] + accountDamageDealt
    AccountStats["Healing"] = AccountStats["Healing"] + accountHealing
    Turbine.PluginData.Save(Turbine.DataScope.Account, "PrimeAccountStats", AccountStats)
end

Stats = class(Turbine.UI.Lotro.Window)
function Stats:Constructor()
    local width = 1100
    local height = 500
    local x = math.floor(Turbine.UI.Display.GetWidth() / 2 - (width /2))
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Lotro.Window.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(x,y);
    self:SetWantsKeyEvents(true)
    self:SetText("Stats")
    self:SetVisible(true)

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 50)
    DescriptionLabel:SetText("Char uptime: " .. Round(CharStats["Time"]/60, 1) .. "min")

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 70)
    DescriptionLabel:SetText("Acc uptime: " .. Round(AccountStats["Time"]/60, 1) .. "min")

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 90)
    DescriptionLabel:SetText("Char reloads: " .. CharStats["Reload"])

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 110)
    DescriptionLabel:SetText("Acc Reloads: " .. AccountStats["Reload"])

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 130)
    DescriptionLabel:SetText("Char Deaths: " .. CharStats["Death"])

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 150)
    DescriptionLabel:SetText("Acc Deaths: " .. AccountStats["Death"])

    --[[

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 170)
    DescriptionLabel:SetText("Char Damage Taken: " .. FormatBigNumber(CharStats["DamageTaken"]))

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 190)
    DescriptionLabel:SetText("Acc Damage Taken: " .. FormatBigNumber(AccountStats["DamageTaken"]))

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 210)
    DescriptionLabel:SetText("Char Damage Dealt: " .. FormatBigNumber(CharStats["DamageDealt"]))

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 230)
    DescriptionLabel:SetText("Acc Damage Dealt: " .. FormatBigNumber(AccountStats["DamageDealt"]))

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 250)
    DescriptionLabel:SetText("Char Healing Received: " .. FormatBigNumber(CharStats["Healing"]))

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 270)
    DescriptionLabel:SetText("Acc Healing Received: " .. FormatBigNumber(AccountStats["Healing"]))

    --]]

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(250, 35)
    DescriptionLabel:SetText("Character KBs")

    local container = Turbine.UI.ListBox()
    container:SetParent(self)
    container:SetSize(200, height - 100)
    container:SetPosition(250, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    containerScrollbar:SetParent( self );
    containerScrollbar:SetPosition( 450 - 10, 50 );
    containerScrollbar:SetSize( 10, height - 100 );
    container:SetVerticalScrollBar( containerScrollbar );

    local SortedEffects = {}
    for key, value in pairs(CharStats["KB"]) do table.insert( SortedEffects, key ) end
    table.sort( SortedEffects )

    for _, value in pairs(SortedEffects) do
        local listItem = Turbine.UI.Control();
        listItem:SetVisible(true)
        listItem:SetSize( 200, 15 );
        listItem:SetMouseVisible(true)
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 15)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetTop(2)
        NameLabel:SetText(value .. " - " .. CharStats["KB"][value])
    
        container:AddItem( listItem );
    end

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(450, 35)
    DescriptionLabel:SetText("Account KBs")

    local container = Turbine.UI.ListBox()
    container:SetParent(self)
    container:SetSize(200, height - 100)
    container:SetPosition(450, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    containerScrollbar:SetParent( self );
    containerScrollbar:SetPosition( 650 - 10, 50 );
    containerScrollbar:SetSize( 10, height - 100 );
    container:SetVerticalScrollBar( containerScrollbar );

    local SortedEffects = {}
    for key, value in pairs(AccountStats["KB"]) do table.insert( SortedEffects, key ) end
    table.sort( SortedEffects )

    for _, value in pairs(SortedEffects) do
        local listItem = Turbine.UI.Control();
        listItem:SetVisible(true)
        listItem:SetSize( 200, 15 );
        listItem:SetMouseVisible(true)
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 15)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetTop(2)
        NameLabel:SetText(value .. " - " .. AccountStats["KB"][value])
    
        container:AddItem( listItem );
    end

    -- Char Deahts

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(650, 35)
    DescriptionLabel:SetText("Character Deaths")

    local container = Turbine.UI.ListBox()
    container:SetParent(self)
    container:SetSize(200, height - 100)
    container:SetPosition(650, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    containerScrollbar:SetParent( self );
    containerScrollbar:SetPosition( 850 - 10, 50 );
    containerScrollbar:SetSize( 10, height - 100 );
    container:SetVerticalScrollBar( containerScrollbar );

    local SortedEffects = {}
    for key, value in pairs(CharStats["KilledBy"]) do table.insert( SortedEffects, key ) end
    table.sort( SortedEffects )

    for _, value in pairs(SortedEffects) do
        local listItem = Turbine.UI.Control();
        listItem:SetVisible(true)
        listItem:SetSize( 200, 15 );
        listItem:SetMouseVisible(true)
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 15)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetTop(2)
        NameLabel:SetText(value .. " - " .. CharStats["KilledBy"][value])
    
        container:AddItem( listItem );
    end

    --Char Deaths
    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(850, 35)
    DescriptionLabel:SetText("Account Deaths")

    local container = Turbine.UI.ListBox()
    container:SetParent(self)
    container:SetSize(200, height - 100)
    container:SetPosition(850, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    containerScrollbar:SetParent( self );
    containerScrollbar:SetPosition( 1050 - 10, 50 );
    containerScrollbar:SetSize( 10, height - 100 );
    container:SetVerticalScrollBar( containerScrollbar );

    local SortedEffects = {}
    for key, value in pairs(AccountStats["KilledBy"]) do table.insert( SortedEffects, key ) end
    table.sort( SortedEffects )

    for _, value in pairs(SortedEffects) do
        local listItem = Turbine.UI.Control();
        listItem:SetVisible(true)
        listItem:SetSize( 200, 15 );
        listItem:SetMouseVisible(true)
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 15)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetTop(2)
        NameLabel:SetText(value .. " - " .. AccountStats["KilledBy"][value])
    
        container:AddItem( listItem );
    end
end
