SwapWarner = class(Turbine.UI.Window)
function SwapWarner:Constructor()
    local width = 750
    local height = 125
    local x = math.floor(Turbine.UI.Display.GetWidth() / 2 - (width/2))
    local y = math.floor(Turbine.UI.Display.GetHeight() / 3 + 100)
    Turbine.UI.Window.Constructor(self);
    self:SetSize(width,height);
    self:SetPosition(x,y);
    self:SetZOrder(1);
  
    self:SetWantsKeyEvents(false)
    self:SetMouseVisible(false)
    self:SetVisible(false)
    --self:SetWantsUpdates(true)
    --self:SetOpacity(0.3)
  
    self.messageBox = Turbine.UI.Label()
    self.messageBox:SetParent(self)
    self.messageBox:SetSize(width,height)
    self.messageBox:SetPosition(0,0)
    self.messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox:SetFont(Settings.EFont)
    self.messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox:SetVisible(true)
    self.messageBox:SetMarkupEnabled(true)
    self.messageBox:SetOutlineColor(OutlineColor)
    self.messageBox:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.messageBox:SetMouseVisible(false)
    self.messageBox:SetText("Swap weapon equipped!")


    SwapWeapons = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeSwapData") 

    if SwapWeapons == nil then
        SwapWeapons = {}
    end

    self.SwapCheck = function(swapName)
        local equipmentCheck = Player:GetEquipment()
        for i = 1, equipmentCheck:GetSize(), 1 do
            local item = equipmentCheck:GetItem(i)
            if item ~= nil then  
                --ChatOutput(item:GetName())      
                if SwapWeapons[item:GetName()] and swapName ~= item:GetName() then
                    self:SetVisible(true)
                end
            end	          
        end
    end

    self.SwapCheck("")

    local equipment = Player:GetEquipment()

    equipment.ItemEquipped = function(sender, args)
        --self:SetVisible(true)
        local item = equipment:GetItem(args.Index)
        if item ~= nil then        
            if SwapWeapons[item:GetName()] then
                self:SetVisible(true)
            end
        end	
    end
    if Tablelength(SwapWeapons) > 0 then
        equipment.ItemUnequipped = function(sender, args)
            --self:SetVisible(false)
            local item = equipment:GetItem(args.Index)
            if item ~= nil then        
                if SwapWeapons[item:GetName()] then
                    self:SetVisible(false)
                    self.SwapCheck(item:GetName())
                end
            end	
        end
    end

    self.SaveData = function()
        Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeSwapData", SwapWeapons);
    end

    self.PrintSwaps = function()
        ChatOutput("<rgb=#0071b8>Swap weapon names for " .. Player:GetName())
        for key, value in pairs(SwapWeapons) do
            ChatOutput("<rgb=#004d00>"..key)
        end
    end

    self.AddSwapWeapon = function(sender, name)
        SwapWeapons[name] = true
        ChatOutput("Added swap: " .. name)
    end

    self.RemoveSwapWeapon = function(sender, name)
        SwapWeapons[name] = nil
        ChatOutput("Removed swap: " .. name)
    end

    self.ListEquipment = function()
        local equipmentCheck = Player:GetEquipment()
        for i = 1, equipmentCheck:GetSize(), 1 do
            local item = equipmentCheck:GetItem(i)
            if item ~= nil then  
                ChatOutput(item:GetName())      
            end	          
        end
    end
end