TargetWindow = class(Turbine.UI.Window)
function TargetWindow:Constructor()
    Turbine.UI.Window.Constructor(self);
    local width = Settings.TWidth
    local height = Settings.THeight2
    local x = Settings.TX
    local y = Settings.TY

    local cooldownTimer = 0
    local Timers = {}
    
    local EffectDictionary = {}

    local UpdateDelay = 0
    local UpdateTime = 0.3
    local EffectIndex = 1
    local MaxEffectPerUpdate = 100

    local PermDelay = 3

    local TimerHeight = 20

    local ResortTimers = false

    local TargetEffects = nil
    local Target = nil
    local TargetHealth = nil
    local TargetTime = Turbine.Engine.GetGameTime()
    local TargetEffectsID = {}
    local TargetEffectsCount = 0

    local ShowAll = Settings.TShowAll
    local DoEffects = Settings.TEffects

    local EmptyString = ""

    local oldGameTime = Turbine.Engine.GetGameTime()

    local TargetEffectsDictionary = TargetWindowEffects

    --self.TargetEffects.self = nil 

    self:SetSize(width,height);
    self:SetPosition(x,y);
    self:SetVisible(true)
    self:SetWantsUpdates(true)
    --Updater:Subscribe(self)
    self:SetMouseVisible(false)
    self:SetOpacity(1)
    --self:SetBackColor(GoldColor)

    self.opacityNameWindow = Turbine.UI.Window()
    self.opacityNameWindow:SetParent(self)
    self.opacityNameWindow:SetSize(width, 30)
    self.opacityNameWindow:SetBackColor(OutlineColor)
    self.opacityNameWindow:SetOpacity(0.3)
    self.opacityNameWindow:SetVisible(true)
    self.opacityNameWindow:SetMouseVisible(true)

    self.opacityNameWindow2 = Turbine.UI.Window()
    self.opacityNameWindow2:SetParent(self)
    self.opacityNameWindow2:SetSize(width, 30)
    --self.opacityNameWindow2:SetBackColor(OutlineColor)
    --self.opacityNameWindow2:SetOpacity(0.3)
    self.opacityNameWindow2:SetVisible(true)
    self.opacityNameWindow2:SetMouseVisible(false)

    self.NameLabel = Turbine.UI.Label()
    self.NameLabel:SetParent(self.opacityNameWindow2)
    self.NameLabel:SetSize(width, 15)
    self.NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.NameLabel:SetMouseVisible(false)
    self.NameLabel:SetMultiline(false)
    self.NameLabel:SetTop(2)

    self.DataLabel =  Turbine.UI.Label()
    self.DataLabel:SetParent(self.opacityNameWindow2)
    self.DataLabel:SetSize(width, 15)
    self.DataLabel:SetTop(15)
    self.DataLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.DataLabel:SetMouseVisible(false)
    self.DataLabel:SetMultiline(false)

    self.TimerContainer = Turbine.UI.Control()
    self.TimerContainer:SetParent(self)
    self.TimerContainer:SetVisible(true)
    self.TimerContainer:SetSize(100, height - 20)
    self.TimerContainer:SetPosition(0, 30)
    self.TimerContainer:SetMouseVisible(false)

    local moveBox = MoveBox(self, width, height, "Target Window")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.UpdateEffects = function()
        if TargetEffects == nil then return end
        --ChatOutput("Target 1: " .. collectgarbage("count")*1024)
        --local startLoopTime = Turbine.Engine.GetGameTime()
        collectgarbage("stop")
        local currentEffect = nil
        local id = nil
        --for i = EffectIndex, EffectIndex + MaxEffectPerUpdate do
        for i = 1, TargetEffects:GetCount() do
            --collectgarbage("stop")
            --ChatOutput("Target 1: " .. collectgarbage("count")*1024)
            currentEffect = TargetEffects:Get(i)
            id = currentEffect:GetID()
            --ChatOutput("Target 2: " .. collectgarbage("count")*1024)
            if TargetEffectsID[id] == nil then
                if currentEffect:GetDuration() < 999999 then TargetEffectsID[id] = true end

                if ShowAll or TargetEffectsDictionary[currentEffect:GetName()] then
                    self.NewTimer(currentEffect)
                end
            end
            currentEffect = nil
            id = nil
            --ChatOutput("Target 3: " .. collectgarbage("count")*1024)

            --[[
            --ChatOutput(i)
            if pcall(function() currentEffect = TargetEffects:Get(i) end) then
                --if Turbine.Engine.GetGameTime() - startLoopTime > 0 then ChatOutput(Turbine.Engine.GetGameTime() - startLoopTime) end
                id = currentEffect:GetID()
                if TargetEffectsID[id] == nil then
                    if currentEffect:GetDuration() < 999999 then TargetEffectsID[id] = true end

                    if TargetWindowEffects[currentEffect:GetName()] then
                        self.NewTimer(currentEffect)
                    end
                end
            else
                --ChatOutput("Error")
                EffectIndex = 1
                return
            end

            --]]
        end
        collectgarbage("restart")
        --EffectIndex = EffectIndex + MaxEffectPerUpdate + 1
    end

        --[[
            if EffectIndex > self.TargetEffects:GetCount() then 
            EffectIndex = 1
            return 
        end
        --ChatOutput(self.TargetEffects:Get(EffectIndex):GetName())
        if TargetEffects[self.TargetEffects:Get(EffectIndex):GetName()] then
            self.NewTimer(self.TargetEffects:Get(EffectIndex))
        end
    --]]

    self.TargetEvents = function()
        --ChatOutput("New Target")
        --[[
        if self.DataLabel:GetText() ~= EmptyString then
            local delta = (Turbine.Engine.GetGameTime() - TargetTime)
            local dps = (TargetHealth - Target:GetMorale())/ delta / 1000
            if dps > 10 and delta > 10 then
                dps = Round(dps, 1)
                local dpsString = "DPS: " ..  dps .. "K"
                self.AddListItem(Target:GetName(), dpsString, Round(delta, 1))
            end
        end
        --]]
        --ChatOutput("Before: " .. collectgarbage("count")*1024)

        -- Reset all variables
        Target = nil
        --TargetEffectsCount = 0

        --ChatOutput("After: " .. collectgarbage("count")*1024)

        -- Start regathering info
        Target = Player:GetTarget()

        if Target ~= nil then 
            --Updater:Subscribe(self)
            self:SetWantsUpdates(true)
            if Target.GetEffects ~= nil then
                TargetEffects = nil
                EffectDictionary = {}
                TargetEffectsID = {}
                TargetHealth = 0
                TargetTime = Turbine.Engine.GetGameTime()
        
                collectgarbage()
                --TargetEffects.self = self
                TargetHealth = Player:GetTarget():GetMorale()
                --UpdateDelay = 0--
                EffectIndex = 1
                --TargetEffectsCount = TargetEffects:GetCount()
                if DoEffects then
                    TargetEffects =  Target:GetEffects()
                    EffectDictionary = {}
                    TargetEffectsID = {}
                end
                self.CombatUpdate()
            end
        else
            --Updater:UnSubscribe(self)
            self:SetWantsUpdates(false)
        end
        self.SetNameText()
        --]]
    end

    self.RefreshData = function()
        if Target ~= nil then 
            if Target.GetEffects ~= nil and DoEffects  then
                TargetEffects =  nil
                EffectDictionary = nil
                TargetEffectsID = nil
                collectgarbage()
                TargetEffects =  Target:GetEffects()
                EffectDictionary = {}
                TargetEffectsID = {}
            end
        end
    end

    Player.TargetChanged = function()
        self.Clear()
        self.TargetEvents()
    end

    self.CombatUpdate = function()
        if Player:IsInCombat() then
            if Target ~= nil then
                self:SetWantsUpdates(true)
            end
            TargetTime = Turbine.Engine.GetGameTime()
            self.SetNameText()
        end
    end

    self.SetNameText = function()
        if Target ~= nil then
            if Target.GetEffects ~= nil and Target:GetMaxMorale() ~= 0  then
                local delta = Turbine.Engine.GetGameTime() - TargetTime
                if TargetHealth < Target:GetMorale() and delta < 1 then
                    TargetHealth = Target:GetMorale()
                end
                local dpsString = nil
                if Player:IsInCombat() and delta > 0 then
                    local dps = Round((TargetHealth - Target:GetMorale())/delta / 1000, 1)
                    dpsString = "DPS: " ..  dps .. "K"
                end
                self.NameLabel:SetText(Target:GetName())
                if dpsString ~= nil then
                    self.DataLabel:SetText(Round((Target:GetMorale() / Target:GetMaxMorale() * 100), 3) .. "% ".. dpsString)
                else
                    self.DataLabel:SetText(Round((Target:GetMorale() / Target:GetMaxMorale() * 100), 3) .. "% ")
                end
            else
                self.NameLabel:SetText(Target:GetName())
                self.DataLabel:SetText("")
            end
        else
            self.NameLabel:SetText("-")
            self.DataLabel:SetText("")
        end
    end

    self.CombatUpdate()

    self.Update = function()   
        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == oldGameTime then
            return(true)
        end
        local delta = currentGameTime - oldGameTime

        UpdateDelay = UpdateDelay - delta

        local CheckUpdate = UpdateDelay < 0

        --We had an update
        for key, value in pairs(Timers) do 
            if value[1]:GetDuration() < 99999 then

                -- Update timer
                value[2] = value[2] - delta
                value[1]:UpdateText(delta)

                -- Remove expired timer
                if value[2] < 0 then 
                    Timers[key] = nil
                    value[1]:Destroy()
                    ResortTimers = true
                end

            -- Check if we want to get an update on permanent buffs
            else
                if CheckUpdate then 
                    if TargetEffects:Contains(value[3]) then
                        value[5] = 0
                    else
                        value[5] = value[5] + UpdateTime
                    end
                    if value[5] > PermDelay then
                        Timers[key] = nil
                        value[1]:Destroy()
                        ResortTimers = true
                    end
                end
            end
        end

        -- Update effects
        if CheckUpdate then
            if DoEffects then
                self.UpdateEffects()
            end
            --[[
            if self.TargetEffects ~= nil then
                UpdateDelay = UpdateTime + 0.015 * self.TargetEffects:GetCount() 
            else
                UpdateDelay = UpdateTime
            end
            --]]
            UpdateDelay = UpdateTime
            
            --Update text
            self.SetNameText()
        end

        -- Resort timers
        if ResortTimers then
            if tablelength(Timers) == 0 then 
                --self:SetWantsUpdates(false) 
                Timers = nil
                collectgarbage()
                Timers = {}
                return
            end
            self.ResortList()
        end

        oldGameTime = currentGameTime
    end

    -- Add a timer
    self.NewTimer = function(effect)
        local effectName = effect:GetName()
        local item = Timers[effectName]
        -- If timer already exists
        if item ~= nil then
            -- Timer already exists 
            if item[3]:GetID() == effect:GetID() then 
                return
            else
                -- Update timer for new effect -- TODO track more effects
                local duration = effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime())
                item[2] = duration
                item[1]:ChangeDuration(duration)
                ResortTimers = true
                item = nil
                effectName = nil
                return
            end
        end

        local maxDuration = effect:GetDuration()
        local duration = effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime())
        -- If permanent change duration to managable amount
        if duration > 999999 then 
            duration, maxDuration = 999999999, 999999999
            local numberLessEffect = string.match(effectName, "%D")
            for key, value in pairs(Timers) do
                if string.match(key, "%D") == numberLessEffect then
                    Timers[effectName] = Timers[key]
                    Timers[key] = nil
                    Timers[effectName][1]:ChangeName(effectName)
                    Timers[effectName][5] = 0
                    item = nil
                    effectName = nil
                    maxDuration = nil
                    duration = nil
                    return
                end
            end
        end

        Timers[effectName] = {Counter2(self.TimerContainer, width, TimerHeight, Tablelength(Timers), maxDuration, effectName, Settings.SPNewFont, TimerColourNormal1, nil, TimerColourNormal3, TimerColourNormal4, TimerColourNormal5, effect:GetIcon(), effect), duration, effect, effectName, 0}

        ResortTimers = true

        item = nil
        effectName = nil
        maxDuration = nil
        duration = nil
    end

    self.Clear = function()
        for key, value in pairs(Timers) do 
            value[1]:Destroy()
            Timers[key] = nil
            --table.remove(Timers, key )
            --PrintTable(Timers)
        end
        if Tablelength(Timers) > 0 then
            self.Clear()
        end
        Timers = nil
        collectgarbage()
        Timers = {}
    end

    --[[
    self.ReOrder = function()
        --ChatOutput("Reorder")

        local SortedList = {}
        for _, value in pairs(Timers) do
            --table.insert( SortedList, {value[1], value[6]/value[2]} )
            table.insert( SortedList, {value[1], value[2]} )
        end
        table.sort( SortedList, Compare )
        for i = 1, #SortedList do
            SortedList[i][1]:SetPosition(0, (i - 1) * TimerHeight) 
        end

        SortedList = nil
        
        if Tablelength(Timers) > 1 then  
            table.sort(Timers, Compare)
        end
        --self.ResortList()
    
        --PrintTable(Timers)
    end
    --]]

    self.ResortList = function()
        local counter = 0
        for _,v in spairs(Timers, function(t,a,b) return t[b][2] < t[a][2] end) do
            v[1]:SetPosition(0, counter * TimerHeight) 
            counter = counter + 1
        end

        ResortTimers = false
    end
    
    --[[
    self.ResortList = function()
        --ChatOutput("Resort")
        local counter = 0
        for _, value in pairs(Timers) do
            value[1]:SetPosition(0, counter * TimerHeight) 
            counter = counter + 1
        end
        --ChatOutput("Resort")
    end
    --]]

    self.TargetEvents()
    self.SetNameText()

    self.ParseBox = Turbine.UI.ListBox()
    self.ParseBox:SetParent(self)
    --self.ParseBox:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) )
    self.ParseBox:SetSize( width, height - 30 )
    self.ParseBox:SetPosition(0, 30)
    self.ParseBox:SetVisible(false)
    --self.ParseBox


    self.opacityNameWindow.MouseClick = function()
        self.ParseBox:SetVisible(not(self.ParseBox:IsVisible()))
        self.TimerContainer:SetVisible(not(self.ParseBox:IsVisible()))
        if self.ParseBox:IsVisible() then
            self.opacityNameWindow2:SetBackColor(OutlineColor)
        else
            self.opacityNameWindow2:SetBackColor()
        end
    end

    self.AddListItem = function(targetName, DPS, Time)
        local listItem = Turbine.UI.Window();
        listItem:SetVisible(true)
        listItem:SetSize( width, 30 );

        local opWIndow1 = Turbine.UI.Window()
        opWIndow1:SetParent(listItem)
        opWIndow1:SetSize(width, 30)
        opWIndow1:SetBackColor(OutlineColor)
        opWIndow1:SetOpacity(0.3)
        opWIndow1:SetVisible(true)
        opWIndow1:SetMouseVisible(false)
    
        local opWindow2 = Turbine.UI.Window()
        opWindow2:SetParent(listItem)
        opWindow2:SetSize(width, 30)
        opWindow2:SetVisible(true)
        opWindow2:SetMouseVisible(false)

        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(opWindow2)
        NameLabel:SetSize(width, 15)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        NameLabel:SetMouseVisible(false)
        NameLabel:SetMultiline(false)
        NameLabel:SetTop(2)
        NameLabel:SetText(targetName)
    
        local DataLabel =  Turbine.UI.Label()
        DataLabel:SetParent(opWindow2)
        DataLabel:SetSize(width, 15)
        DataLabel:SetTop(15)
        DataLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DataLabel:SetMouseVisible(false)
        DataLabel:SetMultiline(false)
        DataLabel:SetText(Time .. "s - " .. DPS)

        if self.ParseBox:GetItemCount() > 6 then
            local item = self.ParseBox:GetItem(1)
            self.ParseBox:RemoveItemAt(1)
            item:SetParent(nil)
            item = nil
        end
        self.ParseBox:AddItem( listItem );
    end
end


