function Round(num, numDecimalPlaces)
    local mult = 10^(numDecimalPlaces or 0)
    local number = math.floor(num * mult + 0.5) / mult
    if (number % 1) == 0 and numDecimalPlaces ~= 0 then
        return tostring(number .. ".0")
    else
        return number
    end
end

function tablelength(T)
    local count = 0
    if T ~= nil then
        for _ in pairs(T) do count = count + 1 end
    end
    return count
end


function Tablelength(T)
    return tablelength(T)
end

function PrintTable(T)
    ChatOutput("Printing list")
    for k, item in pairs(T) do
        ChatOutput(k.." "..item[6])
    end
end


function Compare(a, b)
    --ChatOutput(a[3]..b[3])
    if a ~= nil and b ~= nil then
        return a[2] < b[2]
    end
end

function Compare2(a, b)
    --ChatOutput(a[3]..b[3])
    if a ~= nil and b ~= nil then
        return a[2] > b[2]
    end
end

function ChatOutput(string) Turbine.Shell.WriteLine(string) end

function GetRandomColour() return(Turbine.UI.Color(math.random(), math.random(), math.random())) end

function AddListItem(text, box, ItemSelectedLabel, extraText)
        
    local listItem = Turbine.UI.Control();
    listItem:SetVisible(true)
    listItem:SetSize( 200, 15 );
    listItem:SetMouseVisible(true)

    listItem.MouseClick = function()
        ItemSelectedLabel:SetText(text)
    end

    local ttttext = text

    if extraText ~= nil then
        ttttext = text .. " - " .. extraText
    end

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(listItem)
    NameLabel:SetSize(200, 15)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    NameLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    NameLabel:SetTop(2)
    NameLabel:SetText(ttttext)

    box:AddItem( listItem );
end

function FormatBigNumber(number)
    if number == nil then return 0 end
    local returnString = nil
    if number < 1000 then
        returnString = number
    elseif number >= 1000 and number < 1000000 then
        returnString = Round((number / 1000), 1) .. "k"
    elseif number >= 1000000 and number < 1000000000 then
        returnString = Round((number / 1000000),1) .. "m"
    elseif number >= 1000000000 and number < 1000000000000 then 
        returnString = Round((number / 1000000000), 1) .. "b"
    elseif number >= 1000000000000 then
        returnString = Round((number / 1000000000000), 1) .. "t"
    else
        returnString = number
    end

    return returnString
end

function ClearUI() 
    --if Settings.MEnabled then messageWindow:Clear() end
    
    if Settings.SEnabled then skillCounters:Clear() end
    if Settings.EEnabled then effectsWindow:Clear() end
    if Settings.SPEnabled then skillTimers:Clear() end
    if Settings.SEnabled then skillCounters:Clear() end
    if Settings.SPEnabled then skillTimers:Clear() end
    if Settings.SEnabled then skillCounters:Clear() end
    if Settings.SPEnabled then skillTimers:Clear() end
    if Settings.SEnabled then skillCounters:Clear() end
    if Settings.SPEnabled then skillTimers:Clear() end
end

function spairs(t, order)
    -- collect the keys
    local keys = {}
    for k in pairs(t) do keys[#keys+1] = k end

    -- if order function given, sort by it by passing the table and keys a, b,
    -- otherwise just sort the keys 
    if order then
        table.sort(keys, function(a,b) return order(t, a, b) end)
    else
        table.sort(keys)
    end

    -- return the iterator function
    local i = 0
    return function()
        i = i + 1
        if keys[i] then
            return keys[i], t[keys[i]]
        end
    end
end